﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			  LOOP PROCESS	  	   Version 0.2.0									***/
/***				   				   Dernière Mise à Jour : 10-08-15										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         			 	Gestionnaire Fonction											***/
/***	Ce script archive des boucles et permet de les lancer, les interompres ou modifier leur cadence. 	***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Dynamic {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	
	// —— - - DISPLAY
	import flash.display.MovieClip;
	import flash.display.Sprite;
	//
	// —— - - EVENT
	import flash.events.Event;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class LoopProcess extends MiscTools {
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      					  VARIABLES GLOBALES										  */
		/*		  							 Les variables d'utilisations globales								  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		//*——*//
	  	
		// —————— BOUCLES
		//— Archivage des Boucles
		private var Loops:Object = new Object();
		
		
		// —————— ACTIF
		//— Levier indiquant si le LoopProcess tourne ou non
		public var Active:Boolean = true;
		
		
		// —————— SPEED
		//— Vitesse global du LoopProcess
		public var Speed:Number = 1;

		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function LoopProcess( TheLink:* = null	// ———— - - Lien vers la scène
								   ):void {
			/*—*/
			
			// Établie la connexion
			Connexion( TheLink );
			
			// Calibre la boucle globale
			AddEvents( this , GlobalLoop , "ENTER_FRAME" );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 GLOBALE					  		  				  */
		/*									  Les méthodes privées d'ordre globales. 			  		  		  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - LOOP - - —————————————————————————————————————————— */
		// La boucle globale
		//*—*//
		
	    // —————— GLOBAL LOOP
	    // Boucle permanente du LoopProcess qui active toutes les fonctions listées.
	  
		public function GlobalLoop( event:Event ):void {
			/*—*/
			
			// Si le LoopProcess est actif ———— - -
			if( Active ){
				
				// Pour chaque groupe de boucle —— - -
				for( var iLoops:* in Loops ){
							
					// S'il est Actif —— - -
					if( Loops[ iLoops ].Parametres.Active ){
					
						// Pour chaque boucles dans le groupe —— - -
						for( var iLoop:* in Loops[ iLoops ] ){
							
							// S'il ne s'agit pas des parametres —— - -
							if( iLoop != "Parametres" ){
								
								// Si elle est active —— - -
								if( Loops[ iLoops ][ iLoop ].Parametres.Active ){
									
									// Lance la boucle
									SpeedLaunch( Loops[ iLoops ][ iLoop ].Fonction , 
												 Loops[ iLoops ][ iLoop ].Parametres.Speed + 
												( Loops[ iLoops ].Parametres.Speed - 1 ) + 
												( Speed - 1 ) );
								}
							}
						}
					}
				}
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					    LOOP					  		  				  */
		/*									    Créer, modifier et lancer une boucle 			  		  		  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - SAVE - - —————————————————————————————————————————— */
		// Créer une boucle
		//*—*//
		
	    // —————— NEW GROUP
	    // Création d'un groupe de boucles.
	  
		public function NewLoopGroup( Nom:String , 				// ———— - - Nom du groupe
									  Parametres:Object = null	// ———— - - Parametres du groupe
									 ):void {
			/*—*/
			
			// Arguments par défaut
			Parametres = Parametres || new Object();
			
			// Création du groupe 
			Loops[ Nom ] = new Object();
			//
			// Parametres du groupe
			Loops[ Nom ].Parametres = Parametres;
			//
			// Parametres par défaut
			Loops[ Nom ].Parametres.Active = ( Loops[ Nom ].Parametres.Active != null ) ? Loops[ Nom ].Parametres.Active : true;
			Loops[ Nom ].Parametres.Speed = ( Loops[ Nom ].Parametres.Speed != null ) ? Loops[ Nom ].Parametres.Speed : 1;
		}
	  
				
	   	// —————— NEW LOOP
	   	// Création d'une nouvelle boucle
	  
		public function NewLoop( Groupe:String ,			// ———— - - Nom du groupe
								 Nom:String ,				// ———— - - Nom de la boucle
								 Fonction:* ,				// ———— - - Fonction de la boucle
								 Parametres:Object = null	// ———— - - Les parametres de la boucle
							   ):void {
			/*—*/
			
			// Arguments par défaut
			Parametres = Parametres || new Object();
			
			// Si le groupe de boucles n'existe pas —— - - Le créait
			if( !Loops[ Groupe ] ){ NewLoopGroup( Groupe ); }
			
			// Créait l'objet de la boucle
			Loops[ Groupe ][ Nom ] = new Object();
			//
			// Lui donne ses parametres
			Loops[ Groupe ][ Nom ].Fonction = Fonction;
			Loops[ Groupe ][ Nom ].Parametres = Parametres;
			//
			// Parametres par défaut
			Loops[ Groupe ][ Nom ].Parametres.Active = ( Loops[ Groupe ][ Nom ].Parametres.Active != null ) ? 
														 Loops[ Groupe ][ Nom ].Parametres.Active : true;
			Loops[ Groupe ][ Nom ].Parametres.Speed = ( Loops[ Groupe ][ Nom ].Parametres.Speed != null ) ? 
														 Loops[ Groupe ][ Nom ].Parametres.Speed : 1;
		}
		
		
		
		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Modifier et lancer une boucle
		//*—*//
		
	    // —————— CHANGE LOOP
	    // Modifie l'état d'une boucle ou d'un groupe de boucle
	  
		public function ChangeLoop( Groupe:String , 	// ———— - - Groupe de la boucle
								    Nom:* = "" ,		// ———— - - Nom de la boucle
														//		 ou Speed
														//		 ou Active
									
									Speed:* = 1 ,		// ———— - - Modification de la vitesse de la boucle ( Compatible MathOperator )
														//		 ou Active
									
									Active:* = null		// ———— - - Modification de l'activité de la boucle
								   ):void {
			/*—*/
			
			// Switch des arguments
			Speed = !TypeOf( Nom , "String" ) ? Nom : ( 
					( Nom == "Switch" ) ? Nom : ( 
					TypeOf( StringOrNumber( Nom ) , "Number" ) ? Nom : Speed 
					) );
			Nom = !TypeOf( Nom , "String" ) ? "" : ( 
				  ( Nom == "Switch" ) ? "" : (
				  TypeOf( StringOrNumber( Nom ) , "Number" ) ? "" : Nom 
				  ) );
			
			// Si le groupe existe —— - -
			if( Loops[ Groupe ] ){
				
				// Récupère la cible
				var Cible:Object = ( Nom != "" ) ? Loops[ Groupe ][ Nom ] : Loops[ Groupe ];
				
				// Si la boucle existe ou que ce n'est qu'une demande de groupe —— - -
				if( Cible ){
					
					// Si la valeur Speed est un chiffre ou un élément de MathOperator —— - -
					if( TypeOf( Speed , "Number" ) || 
						TypeOf( Speed , "String" ) && Speed != "Switch" ){
						
						// Modifie la vitesse de la cible
						Cible.Parametres.Speed = Round( MathOperator( Cible.Parametres.Speed , Speed ) , 10 );
						
					// Sinon, si la valeur de Speed est une boolean,string ou qu'il y a un argument Active —— - -
					} else if( TypeOf( Speed , [ "Boolean" , "String" ] ) || Active != null ){
						
						// Switch l'Active
						Active = ( Active != null ) ? Active : Speed;
						
						// Modifie la vitesse de la cible
						Cible.Parametres.Active = ( Speed == "Switch" ) ? !Cible.Parametres.Active : Active;
					}
					
				// Sinon —— - - Trace l'erreur
				} else {
					//
					TraceError( "LoopProcess" , "ChangeLoop" , "La boucle \"" + Nom + "\" n'existe pas." );
				}
										
			// Sinon —— - - Trace l'erreur
			} else {
				//
				TraceError( "LoopProcess" , "ChangeLoop" , "Le groupe \"" + Groupe + "\" n'existe pas." );
			}
		}
		
		
	    // —————— SPEED LAUNCH
	    // Suivant une vitesse, lance X fois une fonction et lui transmet la valeur de vitesse donnée
		// sous deux formes pour une double interprétation
	  
		public function SpeedLaunch( Fonction:* ,		// ———— - - La fonction Launch
							 		 Speed:Number = 1	// ———— - - la vitesse de lancement
							 	   ):void {
			/*—*/
			
			// Convertie la vitesse sous deux formes
			var SpeedLaunch:int = Math.floor( Speed );
			SpeedLaunch = SpeedLaunch >= 1 ? SpeedLaunch : 1;
			//
			Speed = Speed - ( SpeedLaunch - 1 );
			var MultiSpeed:Number = 1 - ( 1 - Speed ) / 10;
			
			// Créait l'objet de vitesse à transmettre
			var SpeedObject:Object = { Speed:Speed , Multiple:MultiSpeed };
			
			// Autant de fois que nécessaire —— - -
			for( var iSpeedLaunch:int = 0 ; iSpeedLaunch <= SpeedLaunch ; iSpeedLaunch++ ){
			
				// Essaye de lancer la fonction avec l'argument de l'objet vitesse —— - -
				//
				try {
					//
					// En argument supplanté —— - -
					Launch( Fonction , SpeedObject );
					
				// Si échoue —— - -
				} catch( e ){
					
					// Réessaye —— - -
					try {
						//
						// En argument additifs —— - -
						Launch( Fonction , null , SpeedObject )
						
					// Si échoue —— - -
					} catch( e ){
						
						// Lance sans l'argument supplémentaire
						Launch( Fonction )
					}
				}
			}
		}
  		
		
		
		
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}