﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			MANIP CHIP	 			Version 0.4.0									***/
/***				   				   Dernière Mise à Jour : 10-08-28										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         				  Outils Généraux												***/
/***	Ce script forme un clip pour qu'il puisse se faire manipuler de différentes façon selon les clips   ***/
/***	qu'il a et le nom qu'il porte.																		***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Dynamic {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	
	// —— - - DISPLAY
	import flash.display.MovieClip;
	//
	// —— - - TEXT
	import flash.text.TextField;
	//
	// —— - - EVENT
	import flash.events.Event;
	import flash.events.MouseEvent;
	//
	// —— - - UTILS
	import flash.utils.*;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	import drOIde.Port.MousePort;
	import drOIde.Dynamic.DynamicTools;
	import drOIde.Visual.TextProcess;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class ManipChip extends MiscTools {
		
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*												   				  										  */
	/*				 	      					  VARIABLES GLOBALES										  */
	/*		  							 Les variables d'utilisations globales								  */
	/*												   				  										  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		//*——*//
		
		// —————— ELEMENT
	    // L'élément paramêtré
		private var Element:*;
		
		// —————— APPLY LIST
	    // Liste des applications possibles et de leur demande respectives
		private var ApplyList:Object = {
											ReactOver:			{ Nom:"Over" 			} ,
											ReactClick:			{ Nom:"Click" 			} ,
											ReactSwitch:		{ Nom:"Switch" 			} ,
											ReactButton:		{ Nom:"Button" 			} ,
											ApplySpeed:			{ Nom:"Speed" 			} ,
											ApplyTarget:		{ Nom:"Target" 			} ,
											ApplyLink:			{ Nom:"Link" 			} ,
											ReactMouseAddict:	{ Nom:"MouseAddict" 	} ,
											ReactMouseNeed:		{ Nom:"MouseNeed"	 	} ,
											ApplyStrip:			{ Nom:"Strip"		,	Enfants:[ "Body" ]	} ,
											ApplyPannel:		{ Nom:"Pannel"	 	,	Enfants:[ "Body" ]	} ,
											ApplyInfinity:		{ Nom:"Infinity"	 	} ,
											ApplyDrag:			{ Nom:"Drag"			} ,
											ApplyMosaic:		{ Nom:"Mosaic"			} ,
											ReactShaker:		{ Nom:"Shaker"			} ,
											ApplyHand:			{ Nom:"Hand"		,	Enfants:[ "Body" , "Corner" ] }
										};
		
		// —————— LINK
	    // Liens vers d'autres scripts
		private var Dynamic:DynamicTools;
		private var Text:TextProcess;
		private var Mouse:*;

		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function ManipChip( Active:Boolean = true 	// ———— - - Si le Check se déclanche
								  ){ 
			/*—*/
			
			// Instance de l'élément porteur
			Element = this;
			
			// Établit la connexion
			Connexion( Element );
			
			// Si le déclanchement doit être immédiat —— - - 
			// ( Rappel : Pour un élément directement présent sur scène, empécher le déclanchement 
			//	 		  se fait en mettant la variable "active" à false dans le clip )
			if( Active ){
				
				// Lance le checking elements
				CountdownLaunch( { Fonction:Check , Argument:false } , 1 );
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 GLOBAL					  		  					  */
		/*								   Méthodes d'exploitation global du script 					  		  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - CHECK - - —————————————————————————————————————————— */
		// Les méthodes qui sonde l'état de l'élément pour lui donner son intelligence
		//*—*//
		
		// —————— CHECK           									 	
		// Vérifie le nom d'un MovieClip pour voir s'il contient un nom relatif pour une fonction
		
		public function Check():void {
			/*—*/
			
			// Établit la connexion
			Connexion( Element );
			
			// Calibre les scripts
			Dynamic = new DynamicTools( Element );
			Text = new TextProcess( Element );
			
			// Si le déclanchement doit se faire —— - -
			if( Element.active != false ){
				
				// Pour chaque applications —— - -
				for( var iApply:* in ApplyList ){
					
					// Récupére l'application
					var Apply:Object = ApplyList[ iApply ];
					
					// Levier activé
					var LevierApply:Boolean = true;
					
					// S'il a un nom —— - -
					if( Apply.Nom ){
						
						// Si ce nom ne se retrouve pas dans le nom de l'élément —— - - Bloque le levier
						if( !FindIn( Element.name , Apply.Nom ) ){
							//
							LevierApply = false;
						}
					}
					
					// S'il a des enfants —— - -
					if( Apply.Enfants ){
						
						// Pour chaque enfant demandé —— - -
						for( var iEnfant:int = 0 ; iEnfant < Apply.Enfants.length ; iEnfant++ ){
							
							// Levier de l'enfant
							var LevierEnfant:Boolean = false;
							
							// Pour chaque clip enfant de l'élément —— - -
							for( var iElementEnfant:int = 0 ; iElementEnfant < Element.numChildren ; iElementEnfant++ ){
								 
								 // S'il existe —— - -
								 if( Element.getChildAt( iElementEnfant ) ){
								 
									 // S'il a le nom —— - - Active le levier
									 if( Element.getChildAt( iElementEnfant ).name == Apply.Enfants[ iEnfant ] ){
										 //
										 LevierEnfant = true;
									 }
								 }
							}
							
							// Si l'on a pas trouvé l'enfant —— - - Bloque le levier
							if( !LevierEnfant ){
								//
								LevierApply = false;
							}
						}
					}
					
					// Si le levier est reté actif —— - -
					if( LevierApply ){
						
						// Applique l'intelligence à l'élément
						This[ iApply ]();
					}
				}
			}
		}
		//
		//
		// —————— CHECK FRAME 1           									 	
		// Vérifie le retour sur la frame 1 pour interrompre l'animation
		public function CheckFrame1( event:Event ):void {
			/*—*/
			
			// S'il est sur la première frame —— - - L'interrompt
			if( event.target.currentFrame == 1 ){ event.target.stop(); }
		}
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 EVENT					  		  					  */
		/*						    Méthodes pour appliquer des intelligences de manipulation 					  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - CALIBRAGE - - —————————————————————————————————————————— */
		// Les intelligences qui calibre l'état de l'élément suivant un cas définit
		//*—*//
		
		// —————— APPLY SPEED
		// L'élément réagit et bouge en fonction de ses vitesses
		
		private function ApplySpeed():void {
			/*—*/
			
			// Lui donne ses vitesse
			Element.xSpeed = Element.xSpeed || 0;
			Element.ySpeed = Element.ySpeed || 0;
			Element.rotationSpeed = Element.rotationSpeed || 0;
			Element.heightSpeed = Element.heightSpeed || 0;
			Element.widthSpeed = Element.widthSpeed || 0;
			Element.alphaSpeed = Element.alphaSpeed || 0;
			
			// Lui donne ses freins
			Element.xBrake = Element.xBrake || 95;
			Element.yBrake = Element.yBrake || 95;
			Element.rotationBrake = Element.rotationBrake || 95;
			Element.heightBrake = Element.heightBrake || 95;
			Element.widthBrake = Element.widthBrake || 95;
			Element.alphaBrake = Element.alphaBrake || 95;
			
			// Lui donne sa boucle de mouvement —— - -
			Element.SpeedLoop = function( event:Event ):void {
				/**/
				
				// Récupère la cible
				var Cible:* = event.target;
				
				// Position
				Cible.x += Cible.xSpeed;
				Cible.y += Cible.ySpeed;
				//
				Cible.xSpeed *= Cible.xBrake / 100;
				Cible.ySpeed *= Cible.yBrake / 100;
				
				// Taille
				SetRealScale( Cible , "+" + Cible.widthSpeed , "width" );
				SetRealScale( Cible , "+" + Cible.heightSpeed , "height" );
				//
				Cible.heightSpeed *= Cible.heightBrake / 100;
				Cible.widthSpeed *= Cible.widthBrake / 100;
				//
				if( Cible.height <= 5 ){ Cible.height = 5; }
				if( Cible.width <= 5 ){ Cible.width = 5; }
				
				// Rotation
				Cible.rotation += Cible.rotationSpeed;
				//
				Cible.rotationSpeed *= Cible.rotationBrake / 100;
				
				// Alpha
				Cible.alpha += Cible.alphaSpeed / 100;
				//
				Cible.alphaSpeed *= Cible.alphaBrake / 100;
				//
				if( Cible.alpha < 0 ){ Cible.alpha == 0; } 
				else if( Cible.alpha > 1 ){ Cible.alpha = 1; }
			}
			//
			AddEvents( Element , Element.SpeedLoop , "ENTER_FRAME" );
		}
		
		
		// —————— APPLY TARGET
		// L'élément réagit et modifie ses valeurs de façon fluide en fonction des valeurs d'une cible ( Objet, clip, etc. )
		
		private function ApplyTarget():void {
			/*—*/
			
			// Lui donne sa vitesse de fluidité
			Element.speed = Element.speed || 10;
			Element.target = Element.target || new Object();
			
			// Lui donne sa boucle de mouvement —— - -
			Element.TargetLoop = function( event:Event ):void {
				/**/
				
				// Récupére l'instance de l'élément
				var Cible:* = event.target;
				
				// Pour chaque valeur que contient la cible
				for( var Valeur:* in Cible.target ){
					
					// Si elle n'est pas null —— - -
					if( Cible.target[ Valeur ] != null ){
						
						// S'il ne s'agit pas de rotation —— - -
						if( Valeur != "rotation" ){
						
							// Déplace le parametres vers cette valeur
							Cible[ Valeur ] = NumberGoTo( Cible[ Valeur ] , Cible.target[ Valeur ] , Cible.speed , 0 );
						
						// S'il s'agit de rotation —— - -
						} else {
							
							// Déplace l'angle vers cette valeur
							AngleGoTo( Cible , Cible.target[ Valeur ] , Cible.speed );
						}
					}
				}
			}
			//
			AddEvents( Element , Element.TargetLoop , "ENTER_FRAME" );
		}
		
		
		// —————— APPLY LINK
		// L'élément réagit et modifie sa forme en tans que lien de deux points
	
		public function ApplyLink():void {
			/*—*/
			
			// Lui donne sa boucle de déformation —— - -
			Element.LinkLoop = function( event:Event ):void {
				/**/
				
				// Récupére l'instance de l'élément
				var Cible:* = event.target;
				
				// S'il a les deux points —— - -
				if( Cible.point1 && Cible.point2 ){
					
					// Applique l'effet de lien
					ApplyLinkEffect( Element , Cible.point1 , Cible.point2 , Cible.positionShift , Cible.sizeShift );
				}
			}
			//
			AddEvents( Element , Element.LinkLoop , "ENTER_FRAME" );
		}
		
		
		// —————— APPLY INFINITY
		// L'élément se duplique de sorte de simuler une toîle sans fin quel que soit son mouvement
	
		public function ApplyInfinity():void {
			/*—*/
			
			// S'il ne contient qu'un seul élément —— - -
			if( Element.numChildren == 1 ){
				
				// Si l'élément n'a pas déjà de classe —— - -
				if( !Element.Classe ){
					
					// Récupère son occurence bibliho
					var Occurence:Class = getDefinitionByName( TypeOf( Element.getChildAt( 0 ) ) ) as Class;
					
					// Si cet élément peut se trouver dans la biblio —— - -
					if( Occurence ){
						
						// Récupère l'élément
						Element.Classe = Occurence;
						
						
						// Donne la boucle d'infinie à l'élément —— - -
						Element.InfinityLoop = function( event:Event ):void {
							/**/
							
							// Récupèration des variables
							var ElementInitial:* = Element.getChildAt( 0 );
							var Classe:Class = Element.Classe || ElementToClass( Element.getChildAt( 0 ) );
							
							// S'il n'y a pas de tableau d'entourage —— - -
							if( !Element.Entoure ){
								
								// Créait le tableau d'entourage
								Element.Entoure = new Array();
							
								// Créait ou récupère la variable de développement
								Element.developpement = Element.developpement || 2;
								
								// Pour chaque ligne —— - -
								for( var m:int = -Element.developpement ; m <= Element.developpement ; m++ ){
									
									// Pour chaque colonne —— - -
									for( var n:int = -Element.developpement ; n <= Element.developpement ; n++ ){
										
										// Créait la donné x,y
										Element.Entoure.push( [ n , m ] );
									}
								}
							}
							
							// Récupère le tableau d'entourage
							var Entoure:Array = Element.Entoure;
							
							// Pour chaque éléments posés précédemment —— - -
							for( var i:int = 1 ; i < Element.numChildren ; i++ ){
								//
								// Annihile cet élément
								DestroyElement( Element.getChildAt( i ) );
							}
							
							// Créait le nouvel élément central proche du point 0,0
							var NouvelElement:* = NewElement( Classe , Element , "NouvelElement" , 
															  { x:-Math.ceil( ( Element.x / ElementInitial.width ) ) 
																  * ElementInitial.width + ElementInitial.width , 
																y:-Math.ceil( ( Element.y / ElementInitial.height ) ) 
																  * ElementInitial.height + ElementInitial.height } );
							
							// Pour chaque élément d'entourage —— - -
							for( var En:int = 0 ; En < Entoure.length ; En++ ){
								
								// Créait un nouvel élément autour
								NewElement( Classe , Element , "NouvelElement" + En , 
										   { x:NouvelElement.x + ( ElementInitial.width * Entoure[ En ][ 0 ] ) , 
											 y:NouvelElement.y + ( ElementInitial.height * Entoure[ En ][ 1 ] ) } );
							}
						}
						//
						// Donne son événement de boucle infinie
						AddEvents( Element , Element.InfinityLoop , "ENTER_FRAME" );
						
					// Sinon —— - -Trace l'erreur
					} else {
						//
						TraceError( "ManipChip" , "ApplyInfinity" , 
									 "Le clip dans l'élément doit être lié dans la bibliothèque." );
					}
				}
			
			// Sinon —— - - Trace l'erreur
			} else {
				//
				TraceError( "ManipChip" , "ApplyInfinity" , 
							 "L'élément ne doit contenir qu'un seul clip." );
			}
		}
		
		
		
		/* —————————————————————————————————————————— - - MOUSE - - —————————————————————————————————————————— */
		// Les intelligences qui permette la manipulation de l'élément pas la souris
		//*—*//
		
		// —————— REACT MOUSE ADDICT							 	
		// Calibrage d'état en proportionnel à la distance souris
	
		public function ReactMouseAddict():void {
			/*—*/
			
			// Initialise le MousePort
			Mouse = Element.Mouse || Mouse || new MousePort( Element );
			
			// Calibre les variables
			Element.distance = Element.distance || Element.width;
			Element.distanceMin = Element.distanceMin || 10;
			//
			Element.shapeMouse = Element.shapeMouse || { scaleX:3 , scaleY:3 };
			
			// Calibre la mémoire
			Element.MemoireFormeSouris = new Object();
			//
			// pour chaque modif —— - -
			for( var Initial:* in Element.shapeMouse ){
				
				// Récupère la forme initiale
				Element.MemoireFormeSouris[ Initial ] = Element[ Initial ];
			}
			
			// Donne la boucle
			Element.MouseAddictLoop = function( event:Event ):void {
				/**/
				
				// Récupère la distance
				var Distance:Number = GetDistance( Element , 
													( Mouse.localX != null ) ? 
													{ x:Mouse.localX( Element.parent ) , y:Mouse.localY( Element.parent ) } :
													{ x:Mouse.x , y:Mouse.y } );
				
				// Si elle est suffisante —— - -
				if( Distance < Element.distance && Distance > Element.distanceMin ){
					
					// pour chaque modif —— - -
					for( var Modif:* in Element.shapeMouse ){
						
						// Distance entre les deux extrêmité
						var EntreDistance:Number = Element.distance - Element.distanceMin;
						//
						var Proportionnelle:Number = ( Element.distance - Distance ) / EntreDistance
						
						// Applique cette modif en proportionnelle
						Element[ Modif ] = Element.MemoireFormeSouris[ Modif ] + 
											   ( Element.shapeMouse[ Modif ] - Element.MemoireFormeSouris[ Modif ] ) * 
											   Proportionnelle;
					}
				
				// Si elle est trop proche —— - -
				} else if( Distance > Element.distanceMin ){
					
					// pour chaque modif en mémoire —— - -
					for( var Modif3:* in Element.MemoireFormeSouris ){
						
						// Applique cette modif
						Element[ Modif3 ] = Element.MemoireFormeSouris[ Modif3 ];
					}
				
				// Si elle est trop loin —— - -
				} else {
					
					// pour chaque modif —— - -
					for( var Modif2:* in Element.shapeMouse ){
						
						// Applique cette modif
						Element[ Modif2 ] = Element.shapeMouse[ Modif2 ];
					}
				}
			}
			//
			// Donne l'événement à l'élément
			AddEvents( Element , Element.MouseAddictLoop , "ENTER_FRAME" );
		}
		
		
		// —————— REACT MOUSE NEED          									 	
		// Positionne un état si la souris est à proximité, sinon, remet par défaut
	
		public function ReactMouseNeed():void {
			/*—*/
			
			// Initialise le MousePort
			Mouse = Mouse || new MousePort( Element );
			
			// Calibre les variables
			Element.xMin = Element.xMin || Element.x;
			Element.yMin = Element.yMin || Element.y;
			//
			Element.xMax = Element.xMax || Element.x + Element.width;
			Element.yMax = Element.yMax || Element.y + Element.height;
			//
			Element.shapeMouse = Element.shapeMouse || { alpha:1 };
			//
			Element.open = ( Element.open == null ) ? false : Element.open;
			//
			Element.speedType = Element.speedType || "Constant";
			Element.speed = Element.speed || 10;
			
			
			// Calibre la mémoire
			Element.MemoireFormeSouris = new Object();
			//
			// pour chaque modif —— - -
			for( var Initial:* in Element.shapeMouse ){
				
				// Récupère la forme initiale
				Element.MemoireFormeSouris[ Initial ] = Element[ Initial ];
			}
			
			// Donne la boucle
			Element.MouseNeedLoop = function( event:Event ):void {
				/**/
				
				// Si la position souris est dedans et qu'il est fermé —— - -
				if( Mouse.localX( Element.parent ) >= Element.xMin
				 && Mouse.localY( Element.parent ) >= Element.yMin
				 && Mouse.localX( Element.parent ) <= Element.xMax
				 && Mouse.localY( Element.parent ) <= Element.yMax 
				 && !Element.open
				 ){
					
					// Ouvre
					Element.open = true;

					// Forme suivante
					Next( "MouseNeedLoopOpen" , Element , Element.shapeMouse , Element.speed , Element.speedType );
				}
				
				// Si la position souris est dehors et qu'il est ouvert —— - -
				if( Mouse.localX( Element.parent ) < Element.xMin
				 || Mouse.localY( Element.parent ) < Element.yMin
				 || Mouse.localX( Element.parent ) > Element.xMax
				 || Mouse.localY( Element.parent ) > Element.yMax 
				 ){
					
					// S'il est ouvert —— - -
					if( Element.open ){
						
						// Ferme
						Element.open = false;
						
						// Forme suivante
						Next( "MouseNeedLoopOpen" , Element , Element.MemoireFormeSouris , Element.speed , Element.speedType );
					}
				}
			}
			//
			// Donne l'événement à l'élément
			AddEvents( Element , Element.MouseNeedLoop , "ENTER_FRAME" , "MouseNeedLoop" );
		}
		
	  
		// —————— APPLY STRIP         									 	
		// Calibrage d'interactivité en mode bande défilante
	
		public function ApplyStrip():void {
			/*—*/
			
			// Initialise le MousePort
			Mouse = Mouse || new MousePort( Element );
			
			// Calibre les variables
			//
			// Vitesse
			Element.speed = 0;
			//
			// Parametres
			Element.speedMax = Element.speedMax || 10;
			Element.acceleration = Element.acceleration || 1;
			Element.brake = Element.brake || 90;
			//
			// Position
			Element.xMin = Element.xMin || Element.Body.x;
			Element.yMin = Element.yMin || Element.Body.y;
			//
			Element.xMax = Element.xMax || Element.Body.x + Element.stage.stageWidth;
			Element.yMax = Element.yMax || Element.Body.y + Element.Body.height;
			//
			Element.right = Element.right || Element.xMax - 50;
			Element.left = Element.left || Element.xMin + 50;
			//
			Element.rightMax = Element.rightMax || Element.Body.x + ( Element.xMax - Element.Body.width );
			Element.leftMax = Element.leftMax || Element.Body.x;
			
			
			// Fonction en boucle
			Element.StripLoop = function( event:Event ):void {
				/**/
				
				// S'il est comprit dans la zone —— - -
				if( Mouse.localX( Element ) > Element.xMin && Mouse.localX( Element ) < Element.xMax
				 && Mouse.localY( Element ) > Element.yMin && Mouse.localY( Element ) < Element.yMax ){
					
					// S'il est à gauche —— - -
					if( Mouse.localX( Element ) < Element.left ){
						//
						// Augmente sa vitesse vers la gauche
						Element.speed += Element.acceleration;
					}
					
					// S'il est à droite —— - -
					if( Mouse.localX( Element ) > Element.right ){
						//
						// Augmente sa vitesse vers la droite
						Element.speed -= Element.acceleration;
					}
				}
				
				// Bump de vitesse
				Element.speed = BumpNumber( Element.speed , -Element.speedMax , Element.speedMax );
				
				// Frein de vitesse
				Element.speed *= Element.brake / 100;
				
				// Applique la vitesse
				Element.Body.x += Element.speed;
				
				// Bump de position
				Element.Body.x = BumpNumber( Element.Body.x , Element.rightMax , Element.leftMax );
			}
			
			// Donne l'événement à l'élément
			AddEvents( Element , Element.StripLoop , "ENTER_FRAME" );
		}
		
		
		// —————— APPLY PANEL           									 	
		// Calibrage d'interactivité en mode panneau défilant
	
		public function ApplyPannel():void {
			/*—*/
			
			// Donne au panneau sa variable de position
			Element.position = Element.position || [ 0 , 0 ];
			Element.positionMax = Element.positionMax || [ Math.round( Math.sqrt( Element.Body.numChildren ) ) , 
														   Math.round( Math.sqrt( Element.Body.numChildren ) ) ];
			
			// Taille de déplacement
			Element.pannelWidth = Element.pannelWidth || Element.Body.getChildAt( 0 ).width;
			Element.pannelHeight = Element.pannelHeight || Element.Body.getChildAt( 0 ).height;
			
			// Position initiale
			Element.PanneauPositionInitialeX = Element.Body.x;
			Element.PanneauPositionInitialeY = Element.Body.y;
			
			// Parametres
			Element.speedType = Element.speedType || "Constant";
			Element.speed = Element.speed || 10;
			Element.arrowShape = Element.arrowShape || "Frame";
			
			
			// Donne au panneau sa méthode de défilement
			Element.PannelChange = function( X:int = 0 ,	// ———— - - Position en X 
											 Y:int = 0		// ———— - - Position en Y
											):void {
				/**/
				
				// Si le défilement en question ne fait pas dépasser les limites en X —— - -
				if( Element.position[ 0 ] + X >= 0 
				 && Element.position[ 0 ] + X < Element.positionMax[ 0 ] ){
					//
					// Passe au suivant
					Element.position[ 0 ] += X;
					
					// Lance la transition
					Next( "PannelChangeX" , 
						  Element.Body ,
						  { x:Element.PanneauPositionInitialeX + Element.pannelWidth * -Element.position[ 0 ] } ,
						  Element.speed ,
						  Element.speedType
						  );
				}
				
				// Si le défilement en question ne fait pas dépasser les limites en Y —— - -
				if( Element.position[ 1 ] + Y >= 0 
				 && Element.position[ 1 ] + Y < Element.positionMax[ 1 ] ){
					//
					// Passe au suivant
					Element.position[ 1 ] += Y;
					
					// Lance la transition
					Next( "PannelChangeY" , 
						  Element.Body , 
						  { y:Element.PanneauPositionInitialeY + Element.pannelHeight * -Element.position[ 1 ] } ,
						  Element.speed ,
						  Element.speedType
						  );
				}
				
				// Calibre les fléche selon leur forme
				//
				// Fleche gauche —— - -
				if( Element.Left && Element.position[ 0 ] - 1 < 0 ){
					
					if( Element.arrowShape == "Frame" && Element.Left ){ 
					
						Element.Left.gotoAndStop( "Inactif" ); 
						Element.Left.mouseEnabled = false;
					}
					//
				} else {
					
					if( Element.arrowShape == "Frame" && Element.Left ){ 
					
						Element.Left.gotoAndStop( "Actif" ); 
						Element.Left.mouseEnabled = true;
					}
				}
				//
				// Fleche droite —— - -
				if( Element.Right && Element.position[ 0 ] + 1 >= Element.positionMax[ 0 ] ){
					
					if( Element.arrowShape == "Frame" && Element.Right ){ 
					
						Element.Right.gotoAndStop( "Inactif" ); 
						Element.Right.mouseEnabled = false;
					
					}
					//
				} else {
						
					if( Element.arrowShape == "Frame" && Element.Right ){ 
						
						Element.Right.gotoAndStop( "Actif" ); 
						Element.Right.mouseEnabled = true;
					}
				}
				//
				// Fleche haut —— - -
				if( Element.Up && Element.position[ 1 ] - 1 < 0 ){
					
					if( Element.arrowShape == "Frame" && Element.Up ){ 
						
						Element.Up.gotoAndStop( "Inactif" ); 
						Element.Up.mouseEnabled = false;
					}
					//
				} else {
					
					if( Element.arrowShape == "Frame" && Element.Up ){ 
					
						Element.Up.gotoAndStop( "Actif" ); 
						Element.Up.mouseEnabled = true;
					}
				}
				//
				// Fleche bas —— - -
				if( Element.Down && Element.position[ 1 ] + 1 >= Element.positionMax[ 1 ] ){
					
					if( Element.arrowShape == "Frame" && Element.Down ){ 
					
						Element.Down.gotoAndStop( "Inactif" ); 
						Element.Down.mouseEnabled = false;
					
					}
					//
				} else {
						
					if( Element.arrowShape == "Frame" && Element.Down ){ 
						
						Element.Down.gotoAndStop( "Actif" ); 
						Element.Down.mouseEnabled = true;
					}
				}
			}
			
			
			// Calibre les boutons pour le défilement
			//
			// Bouton droit —— - -
			if( Element.Right ){ 
				//
				AddEvents( Element.Right , { Fonction:Element.PannelChange , Arguments:[ 1 , 0 ] } , "MOUSE_DOWN" ); 
				Element.Right.stop();
			}
			//
			// Bouton gauche —— - -
			if( Element.Left ){ 
				//
				AddEvents( Element.Left , { Fonction:Element.PannelChange , Arguments:[ -1 , 0 ] } , "MOUSE_DOWN" ); 
				Element.Left.stop();
			}
			//
			// Bouton bas —— - -
			if( Element.Down ){ 
				//
				AddEvents( Element.Down , { Fonction:Element.PannelChange , Arguments:[ 0 , 1 ] } , "MOUSE_DOWN" ); 
				Element.Down.stop();
			}
			//
			// Bouton haut —— - -
			if( Element.Up ){ 
				//
				AddEvents( Element.Up , { Fonction:Element.PannelChange , Arguments:[ 0 , -1 ] } , "MOUSE_DOWN" ); 
				Element.Up.stop();
			}
			
			// Lance un premier défilement pour calibrer les boutons
			Element.PannelChange();
		}
		
		
		// —————— APPLY DRAG
		// Applique un état de drag and drop à l'élément
	
		public function ApplyDrag():void {
			/*—*/
			
			// Récupère les enfants ayant "Anchor" dans leur nom sur le parent
			var ZonesAncres:Array = new Array();
			var limit:*;
			//
			for( var iElement:int = 0 ; iElement < Element.parent.numChildren ; iElement++ ){ 
				
				// S'il a "Anchor" dans son nom ainsi que la partir du nom de l'élément, "Drag" mis à part —— - -
				if( FindIn( Element.parent.getChildAt( iElement ).name , "Anchor" ) 
				 && FindIn( Element.parent.getChildAt( iElement ).name , Pop( Element.name , "Drag" ) ) ){
					
					// L'ajoute au tableau
					ZonesAncres.push( { Zone:Element.parent.getChildAt( iElement ) , anchor:true } );
				}
				
				// S'il a "Limit" dans son nom ainsi que la partir du nom de l'élément, "Drag" mis à part —— - -
				if( FindIn( Element.parent.getChildAt( iElement ).name , "Limit" ) 
				 && FindIn( Element.parent.getChildAt( iElement ).name , Pop( Element.name , "Drag" ) ) ){
					
					// Il est la limit
					limit = Element.parent.getChildAt( iElement );
				}
			}
			
			// Lance le calibrage drag & Drop
			Dynamic.DragAndDrop( Element ,
							   { speed:Element.speed , limit:limit , boomerang:Element.boomerang } ,
							   ZonesAncres
							 );
		}
		
		
		// —————— APPLY HAND          									 	
		// L'élément peut être manipulé sur sa position, rotation et taille
	
		public function ApplyHand():void {
			/*—*/
			
			// Variables
			var Coin:*;
			var Corps:*;
			var Bords:*;
			
			// Pour chacun de ses enfants —— - -
			for( var i:int = 0 ; i < Element.numChildren ; i++ ){
				
				// Prend l'occurence de l'élément
				var Enfant:* = Element.getChildAt( i );
				
				// Main
				if( FindIn( Enfant.name , "Corner" ) >= 1 ){ Coin = Enfant; }
				if( FindIn( Enfant.name , "Body" ) >= 1 ){ Corps = Enfant; }
				if( FindIn( Enfant.name , "Border" ) >= 1 ){ Bords = Enfant; }
			}
			
			// Si on a correctement la racine —— - -
			if( Coin.root || StageLink ){
				
				// Fait disparaître les coins et bordure
				Coin.alpha = 0;
				if( Bords ){ Bords.alpha = 0; }
				
				// Créait l'objet de manipulation par la main
				Element.ManipMain = new Object();
				//
				// Créait les trois objets dans l'objet de manipulation main
				Element.ManipMain.Memory = new Object();
				Element.ManipMain.Manipulation = new Object();
				Element.ManipMain.Fonction = new Object();
				
				// Donne les valeurs de références de mémorisation
				Element.ManipMain.Memory.MouseX = 0;
				Element.ManipMain.Memory.MouseY = 0;
				//
				Element.ManipMain.Memory.Width = 0;
				Element.ManipMain.Memory.Height = 0;
				//
				Element.ManipMain.Memory.X = 0;
				Element.ManipMain.Memory.Y = 0;
				//
				Element.ManipMain.Memory.Rotation = 0;
				//
				Element.ManipMain.Memory.DecalageRotation = 0;
				Element.ManipMain.Memory.DecalageWidth = 0;
				
				// Donne les valeurs booléen de référence de manipulation
				Element.ManipMain.Manipulation.Redim = false;
				Element.ManipMain.Manipulation.Move = false;
				Element.ManipMain.Manipulation.Clik = false;
				
				
				// Fonction au clic sur un coin —— - -
				Element.ManipMain.Fonction.ClicCoin = function( event:MouseEvent ):void {
					/**/
					
					// Instance de l'élément et des objets
					var Cible:* = Element;
					var Memory:Object = Cible.ManipMain.Memory;
					var Manipulation:Object = Cible.ManipMain.Manipulation;
					var Fonction:Object = Cible.ManipMain.Fonction;
					
					// Lance la manipulation par redimentionnement et rotation
					Manipulation.Redim = true;
					
					// Mémorise la position souris
					Memory.MouseX = event.stageX;
					Memory.MouseY = event.stageY;
					//
					// Mémorise la rotation et la largeur
					Memory.Rotation = GetTotal( Element , "rotation" );
					Memory.Width = GetTotal( Element , "width" );
					//
					// Mémorise le décalage par rapport à la souris en rotation et largeur 
					Memory.DecalageRotation = GetAngle( { x:GetTotal( Element , "x" ) , y:GetTotal( Element , "y" ) } , { x:event.stageX , y:event.stageY } );
					Memory.DecalageWidth = GetDistance( { x:GetTotal( Element , "x" ) , y:GetTotal( Element , "y" ) } , { x:event.stageX , y:event.stageY } );
					//
					Memory.ScaleX = Element.scaleX / Math.abs( Element.scaleX );
					Memory.ScaleY = Element.scaleY / Math.abs( Element.scaleY );
					
					// Désactive la présence de l'ensemble pour la souris afin de prévenir le bug de position souris contre le scale négatif
					Corps.parent.mouseEnabled = false;
					Corps.parent.mouseChildren = false;
				}
				
				
				// Fonction au clic sur le corps —— - -
				Element.ManipMain.Fonction.ClicCorps = function( event:MouseEvent ):void {
					/**/
					
					// Instance de l'élément et des objets
					var Cible:* = Element;
					var Memory:Object = Cible.ManipMain.Memory;
					var Manipulation:Object = Cible.ManipMain.Manipulation;
					var Fonction:Object = Cible.ManipMain.Fonction;
					
					// Lance la manipulation par position et le clik s'active pour une destruction potentielle
					Manipulation.Move = true;
					Manipulation.Clik = true;
					
					// Mémorise la position souris
					Memory.MouseX = event.stageX;
					Memory.MouseY = event.stageY;
					//
					// Mémorise la position de l'élément
					Memory.X = Element.x;
					Memory.Y = Element.y;
				}
				
				
				// Fonction au clic sur un bord —— - -
				Element.ManipMain.Fonction.ClicBord = function( event:MouseEvent ):void {
					/**/
					
					// Instance de l'élément et des objets
					var Cible:* = Element;
					var Memory:Object = Cible.ManipMain.Memory;
					var Manipulation:Object = Cible.ManipMain.Manipulation;
					var Fonction:Object = Cible.ManipMain.Fonction;
					
					// Lance la manipulation par redimentionnement et rotation
					Manipulation.Miroir = true;
					
					// Mémorise la position souris
					Memory.MouseX = event.stageX;
					Memory.MouseY = event.stageY;
					//
					Memory.ScaleX = Element.scaleX;
					Memory.ScaleY = Element.scaleY;
				}
				
				
				// Fonction au relachement souris —— - -
				Element.ManipMain.Fonction.Relache = function( event:MouseEvent ):void {
					/**/
					
					// Instance de l'élément et des objets
					var Cible:* = Element;
					var Memory:Object = Cible.ManipMain.Memory;
					var Manipulation:Object = Cible.ManipMain.Manipulation;
					var Fonction:Object = Cible.ManipMain.Fonction;
					
					// Arrêt des manipulations de position et redimensionnement
					Manipulation.Redim = false;
					Manipulation.Move = false;
					Manipulation.Miroir = false;
					
					// Si on a pas bougé la souris —— - -
					if( Manipulation.Clik ){ 
						//
						// Retire les événements de souris sur le stage
						RemoveEvents( StageLink , Element.ManipMain.Fonction.Relache , "MOUSE_UP" , Element.name + "Relache" );
						RemoveEvents( StageLink , Element.ManipMain.Fonction.Boucle , "MOUSE_MOVE" , Element.name + "Boucle" );
						
						// Déruit l'élément 
						DestroyElement( Element ); 
					}
					
					// Réactive la présence souris du père
					Corps.parent.mouseEnabled = true;
					Corps.parent.mouseChildren = true;
				}
				
				
				// Fonction au mouvement souris —— - -
				Element.ManipMain.Fonction.Boucle = function( event:MouseEvent ):void {
					/**/
					
					// Instance de l'élément et des objets
					var Cible:* = Element;
					var Memory:Object = Cible.ManipMain.Memory;
					var Manipulation:Object = Cible.ManipMain.Manipulation;
					var Fonction:Object = Cible.ManipMain.Fonction;
					
					// Si on est en train de redimensionner —— - -
					if( Manipulation.Redim ){
						
						// Mémorise la rotation de l'élément puis la fait passer à 0
						var MemoRotation:Number = Element.rotation;
						Element.rotation = 0;
						
						// Mémorise la largeur de l'élément pour l'homotéthie
						var MemoWidth:Number = Element.width;
						//
						// Modifie la largeur en relation avec le mouvement souris
						Element.width = GetDistance( { x:GetTotal( Element , "x" ) , y:GetTotal( Element , "y" ) } , 
													   { x:event.stageX , y:event.stageY } ) 
													  + Memory.DecalageWidth;
						Element.height *= ( Element.width / MemoWidth );
						
						// Réaplique la rotation de l'élément
						Element.rotation = MemoRotation;
						
						// Modifie la rotation de l'élément en fonction du mouvement souris
						Element.rotation = GetAngle( { x:GetTotal( Element , "x" ) , y:GetTotal( Element , "y" ) } ,
													 { x:event.stageX , y:event.stageY } ) 
													  - Memory.DecalageRotation + Memory.Rotation;
													  
						Element.scaleX *= Memory.ScaleX;
						Element.scaleY *= Memory.ScaleY;
					}
					
					
					// Si on est en train de repositionner —— - -
					if( Manipulation.Move ){
						
						// Modifie la position de l'élément en fonction du mouvement souris
						Element.x = Memory.X + ( event.stageX - Memory.MouseX );
						Element.y = Memory.Y + ( event.stageY - Memory.MouseY );
						
						// Bump la position souris s'il le faut
						if( Manipulation.BumpDroit && Element.x < Manipulation.BumpDroit ){ Element.x = Manipulation.BumpDroit; }
						if( Manipulation.BumpGauche && Element.x > Manipulation.BumpGauche ){ Element.x = Manipulation.BumpGauche; }
						if( Manipulation.BumpHaut && Element.y < Manipulation.BumpHaut ){ Element.y = Manipulation.BumpHaut; }
						if( Manipulation.BumpBas && Element.y > Manipulation.BumpBas ){ Element.y = Manipulation.BumpBas; }
					}
					
					
					// Si on est en train de faire un effet miroire —— - -
					if( Manipulation.Miroir ){
						
						// Modifie le Scale positif/négatif suivant la direction souris
						if( event.stageX < Memory.MouseX - 20 ){ Element.scaleX = -Memory.ScaleX; }
						else { Element.scaleX = Memory.ScaleX; }
						//
						if( event.stageY < Memory.MouseY - 20 ){ Element.scaleY = -Memory.ScaleY; }
						else { Element.scaleY = Memory.ScaleY; }
					}
					
					// Fait passer la potentiallité de destruction à faux
					Manipulation.Clik = false;
				}
				//
				// Donne tout les événements
				AddEvents( Coin , Element.ManipMain.Fonction.ClicCoin , "MOUSE_DOWN" , "ClicCoin" );
				AddEvents( Corps , Element.ManipMain.Fonction.ClicCorps , "MOUSE_DOWN" , "ClicCorps" );
				if( Bords ){ AddEvents( Bords , Element.ManipMain.Fonction.ClicBord , "MOUSE_DOWN" , "ClicBord" ); }
				AddEvents( StageLink , Element.ManipMain.Fonction.Relache , "MOUSE_UP" , Element.name + "Relache" );
				AddEvents( StageLink , Element.ManipMain.Fonction.Boucle , "MOUSE_MOVE" , Element.name + "Boucle" );
				
			// Si on a pas correctement la racine et qu'on doit dire les erreurs —— - - Trace l'erreur
			} else {
				//
				TraceError( "ModelChip" , "Main" , [ "L'élément ne peut pas être conditionné en élément manipulable sans une instance de la scène." , 
													"Comme cet élément a été intégré dynamiquement, vous devez lui donner « stage » par " , 
													"sa variable « StageLink »" ] );
			}
		}
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 REACT					  		  					  */
		/*						Méthodes pour appliquer des réactions suivant des cas de figures				  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - MOUSE - - —————————————————————————————————————————— */
		// Les méthodes qui font réagir l'élément aux actions souris
		//*—*//
		
		// —————— REACT OVER
		// L'élément lance son animation au survol
		
		private function ReactOver():void {
			/*—*/
			
			// Il s'animera au rollOver
			AddEvents( Element , { Fonction:Element.play } , 	"MOUSE_OVER" );
			AddEvents( Element , Element.CheckFrame1 , 		"ENTER_FRAME" );
			
			// Place l'animation de l'élément sur la première frame
			Element.gotoAndStop( 1 );
		}
		
		
		// —————— REACT CLICK
		// L'élément lance son animation au click
		
		private function ReactClick():void {
			/*—*/
			
			// Il s'animera au rollOver
			AddEvents( Element , { Fonction:Element.play } , 	"MOUSE_DOWN" );
			AddEvents( Element , Element.CheckFrame1 , 		"ENTER_FRAME" );
			
			// Place l'animation de l'élément sur la première frame
			Element.gotoAndStop( 1 );
		}
		
		
		// —————— REACT SWITCH
		// L'élément lance ou interrompt son animation au click
		
		public function ReactSwitch():void {
			/*—*/
			
			// Créait la variable de lecture
			Element.playing = Element.playing || false;
			//
			// Interrompt si pas de lecture
			if( !Element.playing ){ Element.gotoAndStop( 1 ); }
			
			// Lui donne sa fonction au clic —— - -
			Element.Switch = function():void {
				
				// Switch la lecture
				Element.playing = !Element.playing;				
				//
				// Interrompt si pas de lecture, sinon, la relance
				if( !Element.playing ){ Element.stop(); }
				else { Element.play(); }
			}
			//
			// Lui donne ses événements
			AddEvents( Element , Element.Switch , "MOUSE_DOWN" );
		}
		
		
		// —————— REACT BUTTON
		// L'élément modifie ses états suivant la souris et ses variables
		
		public function ReactButton():void {
			/*—*/
			
			/* —— - - OVER - - —— */
			/**/
					
			// Lui donne sa fonction Over —— - -
			Element.Over = function():void {
				
				// Est survolé
				Element.over = true;
				
				// Lance les déformations —— - -
				if( Element.overStats ){  
					//
					Next( "ButtonNextOver" , 
						  Element , 
						  Element.overStats , 
						  Element.overSpeed || 20 ,
						  Element.overType || "Deceleration" );
				}
			}
			
			
			/* —— - - OUT - - —— */
			/**/
					
			// Lui donne sa fonction Out —— - -
			Element.Out = function():void {
				
				// N'est plus survolé
				Element.over = false;
				
				// Lance le relachement s'il est toujours appuyé —— - -
				if( Element.down ){
					//
					Element.Up();
				}
				
				// Lance les déformations —— - -
				if( Element.outStats ){  
					//
					Next( "ButtonNextOut" , 
						  Element , 
						  Element.outStats , 
						  Element.outSpeed || 20 ,
						  Element.outType || "Deceleration" );
				}
			}
			
			
			/* —— - - DOWN - - —— */
			/**/
					
			// Lui donne sa fonction Down —— - -
			Element.Down = function():void {
				
				// Est clické
				Element.down = true;
				
				// Lance les déformations —— - -
				if( Element.downStats ){  
					//
					Next( "ButtonNextDown" , 
						  Element , 
						  Element.downStats , 
						  Element.downSpeed || 20 ,
						  Element.downType || "Deceleration" );
				}
			}
			
			
			/* —— - - UP - - —— */
			/**/
					
			// Lui donne sa fonction Up —— - -
			Element.Up = function():void {
				
				// N'est plus clické
				Element.down = false;
				
				// Lance les déformations —— - -
				if( Element.upStats ){  
					//
					Next( "ButtonNextUp" , 
						  Element , 
						  Element.upStats , 
						  Element.upSpeed || 20 ,
						  Element.upType || "Deceleration" );
				}
			}
			
			
			/* —— - - EVENEMENT - - —— */
			/**/
					
			// Lui donne ses événements
			AddEvents( Element , Element.Over 	, "MOUSE_OVER" 	);
			AddEvents( Element , Element.Out 	, "MOUSE_OUT" 	);
			AddEvents( Element , Element.Down 	, "MOUSE_DOWN" 	);
			AddEvents( Element , Element.Up 	, "MOUSE_UP" 	);
		}
		
		
		// —————— REACT SHAKER
		// Lance une méthode suivant qu'on secoud l'élément
	
		public function ReactShaker():void {
			/*—*/
			
			// Applique la possibilité de le secouer
			Dynamic.DragAndDrop( Element , 
							   {
								   	speed:Element.speed || 10 ,
									rightLimit:Element.x + ( Element.bumpX || 0 ) + ( Element.bump || 10 ) ,
									leftLimit:Element.x - ( Element.bumpX || 0 ) - ( Element.bump || 10 ) ,
									downLimit:Element.y + ( Element.bumpY || 0 ) + ( Element.bump || 10 ) ,
									upLimit:Element.y - ( Element.bumpY || 0 ) - ( Element.bump || 10 )
							   }
							 );
			
			// Donne l'objet de SecouePosition à l'élément
			Element.SecouePositionObjet = new Object();
			//
			// Lui donne ses paramètres
			Element.SecouePositionObjet.Palier = 0;
			
			// Donne la boucle à l'élément
			Element.ShakerLoop = function( event:Event ):void {
				
				// Si on le déplace —— - -
				if( Element.DragAndDrop.Actif 
				 && !NearEqual( Element.SecouePositionObjet.MemoX , Element.x , Element.sensibility || 6 )
				 && !NearEqual( Element.SecouePositionObjet.MemoY , Element.y , Element.sensibility || 6 )
				  ){
					
					// Augmente le palier
					Element.SecouePositionObjet.Palier += Element.Monte || 10;
					
					// Si le palier a atteint son seuil
					if( Element.SecouePositionObjet.Palier >= 50 ){
						
						// Lance sa fonction
						Launch( Element.fonction );
						
						// Remet le palier à zéro s'il le faut
						if( !Element.keep ){
							//
							Element.SecouePositionObjet.Palier = 0
						}
					}
					
				// Si on ne le déplace pas —— - - Et si le palier est supérieur
				} else if( Element.SecouePositionObjet.Palier > 0 ){
					//
					Element.SecouePositionObjet.Palier -= Element.recuperation || 1;
				}
				
				// Mémorise la position
				Element.SecouePositionObjet.MemoX = Element.x;
				Element.SecouePositionObjet.MemoY = Element.y;
			}
			//
			AddEvents( Element , Element.ShakerLoop , "ENTER_FRAME" );
		}
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 APPLY					  		  					  */
		/*									Méthodes pour appliquer un état statique				  			  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - SHAPE - - —————————————————————————————————————————— */
		// Les méthodes qui appliquent un état en relation avec la forme de l'élément
		//*—*//
		
		// —————— APPLY MOSAIC
		// Applique une mosaique
	
		public function ApplyMosaic():void {
			/*—*/
			
			// Si le clip a une classe liée —— - -
			if( ElementToClass( Element.getChildAt( 0 ) , false ) ){
				
				// Cache l'initial
				Element.getChildAt( 0 ).visible = false;
				
				// Arguments par défauts
				var DecalageInterne = new Object();
				//
				DecalageInterne.x = Element.shiftInternX || 0;
				DecalageInterne.y = Element.shiftInternY || 0;
				
				// Par défaut, la largeur et la hauteur sont prises des dimentions de la scène
				var Largeur:Number = Element.mosaicWidth || StageLink.stageWidth;
				var Hauteur:Number = Element.mosaicHeight || StageLink.stageHeight;
				
				// Récupération de sa hauteur et largeur
				var TailleLargeur:Number = 0;
				var TailleHauteur:Number = 0;
				//
				// Par défaut, les décalages sont la moitiés de la taille du clip
				var DecalageX:Number = Element.shiftX || 0;
				var DecalageY:Number = Element.shiftY || 0;
				
				// Évalue un pourcentage du nombre de clip par hauteur et largeur
				var NombreLargeur:Number = 0;
				var NombreHauteur:Number = 0;
	
				// Pour chaque clip à insérer en hauteur —— - -
				for( var i:int = 0 ; i <= NombreHauteur ; i++ ){
					
					// Pour chaque clip à insérer en largeur —— - -
					for( var j:int = 0 ; j <= NombreLargeur ; j++ ){
						
						// Créait et affiche un clip
						var NouveauClip = NewElement( ElementToClass( Element.getChildAt( 0 ) ) , Element , "Body" + i + "_" + j );
						
						// Définit les valeurs si elles ne le sont pas déjà
						TailleLargeur = TailleLargeur || NouveauClip.width - 1;
						TailleHauteur = TailleHauteur || NouveauClip.height - 1;
						//
						NombreLargeur = NombreLargeur || Largeur / ( TailleLargeur + DecalageInterne.x );
						NombreHauteur = NombreHauteur || Hauteur / ( TailleHauteur + DecalageInterne.y );
						
						// Positionne ce clip dans le conteneur
						NouveauClip.x = j * TailleLargeur + DecalageX + ( DecalageInterne.x * j );
						NouveauClip.y = i * TailleHauteur + DecalageY + ( DecalageInterne.y * i );
					}
				}
			
			// Si le clip n'a pas de classe lié —— - - Trace l'erreur
			} else {
				//
				TraceError( "ManipChip" , "Mosaique" , 
							 "Le clip prit pour exemple pour faire la mosaique doit être lié dans la bibliothéque." );
			}
		}
		
		
		
		
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}