﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			WEB LINK	  			Version 0.5.0									***/
/***				   				   Dernière Mise à Jour : 10-09-06										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         				   Liaison Externe												***/
/***	Ce script établit la connection avec des pages html, JavaScript, php ou d'autres codes de type web, ***/
/***	serveur ou client.																					***/
/***												      													***/
/***	Avec les scripts php appropriés, elle permet d'établir des connections avec des bases de données, 	***/
/***	etc.																							 	***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***	ATTENTION    																						***/
/***	Concernant les connexion à des éléments JavaScript/Html/Php/Xml sur des sites externes    			***/
/***												      													***/
/***	Ce types de connexions ne fonctionnent pas par défaut pour des raisons de sécurité.	    			***/
/***	Afin de les rendres possibles, il faut placer un fichier Xml ( Généralement nommé     				***/
/***	"crossdomain.xml" ) sur la racine du site récepteur.								    			***/
/***	Ce fichier Xml doit contenir le code suivant :										    			***/
/***												      													***/
/***	<?xml version="1.0" encoding="utf-8"?>						      									***/
/***		<cross-domain-policy>							      											***/
/***			<allow-access-from domain="www.monSite.com" to-ports="*" />							      	***/
/***		</cross-domain-policy>							      											***/
/***												      													***/
/***	Remplacer "monSite" par le nom du site émetteur et le "*" de to-ports par n'importe quelle valeur 	***/
/***	s'il faut une restriction particulière sur l'accés.													***/
/***	Bien entendu, il est parfaitement possible de cumuler la ligne "allow-access-from".				 	***/
/***												      													***/
/***	Ce sera uniquement grâce à ça que vous pourrez établire une connexion entre deux sites distants. 	***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Link {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	 
	// —— - - DISPLAY
	import flash.display.MovieClip;
	import flash.display.LoaderInfo;
	//
	// —— - - NET
	import flash.net.URLRequest;
	import flash.net.URLLoader;
	import flash.net.URLVariables;
	import flash.net.URLRequestMethod;
	import flash.net.navigateToURL;
	import flash.net.SharedObject;
	import flash.net.URLLoaderDataFormat;
	import flash.net.URLRequestHeader;
	//
	// —— - - EXTERNAL
	import flash.external.ExternalInterface;
	//
	// —— - - EVENT
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	import drOIde.Link.PaperTools;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	
	public class WebLink extends MiscTools {
		
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*												   				  										  */
	/*				 	      					  VARIABLES GLOBALES										  */
	/*		  							 Les variables d'utilisations globales								  */
	/*												   				  										  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		//*——*//
		
		// —————— LINK - MIND
		// Le lien vers la globalité MIND
		public var Link_MIND:String = "";
		
		
		// —————— SCENE NAME
		// Le nom du flash dans sa page Html
		public var SceneName:String = "";
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function WebLink( TheLink:* = null	// ———— - - Le lien vers la scène
								   ):void {
			/*—*/
			
			// S'il n'y a pas de lien —— - - Trace l'erreur
			if( !Connexion( TheLink ) ){
				//
				TraceError( "WebLink" , "Initialisation" , 
							 "Vous devez donnr un lien vers la scène au script." );
				
			} else {
				
				// Récupère le nom du flash
				SceneName = GetSceneName( TheLink );
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 HTML					  		  					  */
		/*										Connexion avec des pages Html 					  				  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - EMISSION - - —————————————————————————————————————————— */
		// Les méthodes pour transmettre des appels à des pages Html
		//*—*//
		
		// —————— GET URL
	  	// Ouvre directement une page web
	  
		public function GetURL( Lien:String = "google.com" ,	// ———— - - Lien
							    Type:String = "_blank" ,		// ———— - - Type de changemen de page
								Absolue:Boolean = true			// ———— - - Si le lien est absolue ou relatif
							   ):void {
			/*—*/
			
			// Si on est en absolue —— - -
			if( Absolue ){
				
				// Insére les "http://"  s'il n'y sont pas
				if( !FindIn( Lien , "http://" ) ){ Lien = "http://" + Lien; }
			}
			
			// Définit la requête
			var RequeteURL:URLRequest = new URLRequest( Lien );      
			
			// Lance l'ouverture
			navigateToURL( RequeteURL , Type );
		}
	  
	  
		// —————— SET SHARE VAR
		// Envoie une sauvegarde par cookie
		//
		// ATTENTION :
		// Il peut arriver que cette méthode plante, dans le genre gros plantage puisque cela provoque la fermeture
		// immédiate du fichier voir de tout votre environnement Flash.
		// Si c'est le cas, cela viens du fait que vous n'avez pas permit un accés suffisant à l'espace de stockage de votre
		// disque dur pour votre application Flash.
		// Pour régler ce problème, il vous suffit de cliquer droit dans votre application Flash, d'aller dans "Stockage" 
		// ( L'onglet en forme de dossier ) et de faire la jauge sur "Illimité".
	  
		public function SetShareVar( Nom:String ,	// ———— - - Nom de la sauvegarde
									 Valeur:*		// ———— - - Valeur de la sauvegarde
									):* {
			/*—*/
			
			// Récupére la sauvegare par le biais d'un SharedObject
			var Sauvegarde:SharedObject = SharedObject.getLocal( Nom );
			
			// Modifie la valeur
			Sauvegarde.data[ Nom ] = Valeur;
			
			// Enregistre la modification
			Sauvegarde.flush();
		}
		
		
		
		/* —————————————————————————————————————————— - - RECEPTION - - —————————————————————————————————————————— */
		// Les méthodes pour réceptionner des valeurs issues de l'Html
		//*—*//
		
		// —————— GET FLASH VAR
		// Récupère une variable transmise en flashVars
		
		public function GetFlashVar( Nom:String  	// ———— - - Le Nom de la variable
									):String {
			/*—*/
				
			// Renvoie la variable
			return( StageLink.loaderInfo.parameters[ Nom ] );
		}
		
		
		// —————— GET SHARE VAR
	  	// Récupére une sauvegarde cookie par son nom
	  
		public function GetShareVar( Nom:String  	// ———— - - Le Nom de la variable
									):* {
			/*—*/
			
			// Récupére la sauvegare par le biais d'un SharedObject
			var Sauvegarde:SharedObject = SharedObject.getLocal( Nom );
			
			// Retourne la valeur recherchée
			return( ( Sauvegarde.data[ Nom ] != undefined ) ? String( Sauvegarde.data[ Nom ] ) : null );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					JAVASCRIPT					  		  				  */
		/*										Connexion avec du code JavaScript 					  			  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables utilisées pour les méthodes de cet ensemble
		//*—*//
		
		// —————— LINK - PHP CYB02G
		// Les liens vers la page de traitement bridge du cybORg
		public var Link_PHPcybORg:String = "";
		public var Link_PHPcybORgRoot:String = "";
		
		
		
		/* —————————————————————————————————————————— - - EMISSION - - —————————————————————————————————————————— */
		// Les méthodes pour communiquer avec du code JavaScript
		//*—*//
		
		// —————— JS SEND
	  	// Lance un code souhaité en JavaScript
	  	// 
	  	// Rappel : La fonction ne marche que sur Internet directement
	  
		public function JSSend( Code:* ,				// ———— - - Code JavaScript à lancer sous forme de tableau ou de String
								    Fonction:* = null		// ———— - - Fonction à lancer en fin de code s'il y a lieu
									):void {
			/*—*/
			
			// Convertie le code
			Code = CapsuleArray( Code );
			var PreCode:Array = new Array();
			var PostCode:Array = new Array();
			
			// S'il y a une fonction de retour —— - -
			if( Fonction ){
				
				// Créait l'objet pour la méthode retour 
				var ObjetRetour:Object = new Object();
				//
				// Donne à cet objet la fonction de retour ▼
				ObjetRetour.Fonction = function():void {
					
					// Elle lance l'objet launch de fonction retour
					Launch( Fonction );
				}
				
				// Définit la fonction de l'objet retour comme fonction callBack liée au JavaScript
				ExternalInterface.addCallback( "JSSendRetour" , ObjetRetour.Fonction );
				
				// S'il n'est pas en Asynchrone —— - -
				if( !Fonction.Asynchrone ){ 
				
					// Donne le code supplémentaire pour le retour à la fin du code
					PostCode.push( JSPrecom_Return( "JSSendRetour" ) ); 
					
				// S'il est en asynchrone —— - -
				} else {
				
					// Donne le code supplémentaire pour le retour à la fin du code dans une fonction
					PostCode.push( "function JSSendRetourFonction(){" + 
								   JSPrecom_Return( "JSSendRetour" ) +
								   "};" ); 
				}
			}
			
			// Compile le code
			var CodeSortie:String = Code.join( "" ) + PreCode.join( "" ) + PostCode.join( "" );
			Trace(CodeSortie)
			// Lance le code sous forme JavaScript
			navigateToURL( new URLRequest( "javascript:" + 
										   CodeSortie
										  ) , "_self");
		}
	  	
		
		// —————— JS LAUNCH
	  	// Lance une fonction Javascript
	  
		public function JSLaunch( Fonction:String = "alert" ,	// ———— - - Nom de la fonction à lancer
								  Arguments:* = null			// ———— - - Arguments à donner à la fonction
								):void {
			/*—*/
			
			// Définit l'argument de type alerte si on n'a indiqué aucun argument
			if( Fonction == "alert" && !Arguments ){ Arguments = [ "!" ]; }
			
			// Arguments par défaut
			Arguments = Arguments || new Array();
			
			// Convertie le commencement de la fonction
			Fonction = Fonction + "( ";
			
			// Pour chaque arguments —— - -
			for( var i:int = 0 ; i < Arguments.length ; i++ ){
				//
				// Ajoute l'argument
				Fonction += ( isNaN( Number( Arguments[ i ] ) ) ) ? "\"" + Arguments[ i ] + "\"" : Arguments[ i ];
				//
				// Ajoute la virgule si ce n'est pas le dernier
				if( i != Arguments.length - 1 ){ Fonction += " , " }
			}
			
			// Convertie la fin de la fonction
			Fonction = Fonction + " );";
			
			// Lance le code
			JSSend( Fonction );
		}
	  
	  
		// —————— JS GET
	  	// Récupère les variables transmisent en Get et les retournes sous une fonction
	  	//
	  	// ◘02◘ — cybORg Need
	  	// La liaison avec cybORg doit être établie dans la page pour que cette méthode fonctionne
	  
		public function JSGet( Fonction:*	// ———— - - Fonction retour réceptionnant les valeurs
							  ):void {
			/*—*/
			
			// Construit le code
			var Code:Array = [ "var Gets = getGet();" ,
							   "var Sortie = \"\";" ,
							   "for( var Element in Gets ){" ,
							   "Sortie += Element + \"=\" + Gets[ Element ] + \"&\";" ,
							   "};" ,
							   JSPrecom_Return( "JSGetRetour" , "Sortie" )
							  ]
			
			// Créait l'objet pour la méthode retour 
			var ObjetRetour:Object = new Object();
			//
			// Donne à cet objet la fonction de retour ▼
			ObjetRetour.Fonction = function( Get:* ):void {
				
				// Convertie le résultat Get en objet
				var ResultatGet:Object = new Object();
				//
				Get = Get.split( "&" );
				Get.pop();
				//
				for( var Element:* in Get ){
					//
					ResultatGet[ Get[ Element ].split( "=" )[ 0 ] ] = Get[ Element ].split( "=" )[ 1 ];
				}
				
				// Elle lance l'objet launch de fonction retour avec un objet contenant toutes les variables get en tans qu'argument additif
				Launch( Fonction , ResultatGet );
			}
				
			// Définit la fonction de l'objet retour comme fonction callBack liée au JavaScript
			ExternalInterface.addCallback( "JSGetRetour" , ObjetRetour.Fonction );
			
			// Lance le code JavaScript
			JSSend( Code );
		}
	  
	  
		// —————— JS MAIL
	  	// Envoie un mail par le biais du JavaScript
	  	//
	  	// ◘02◘ — cybORg Need
	 	 // La liaison avec cybORg doit être établie dans la page pour que cette méthode fonctionne
	  
		public function JSMail( Contact:String ,			// ———— - - La Personne à contacter
								Objet:String ,				// ———— - - L'Objet du mail
								Contenu:String ,			// ———— - - Le Contenu du mail
								Parametres:Object = null ,	// ———— - - Les Paramètres du mail
								Fonction:* = null			// ———— - - La Fonction de retour
							   ):void {
			/*—*/
			
			// S'il y a une fonction —— - -
			if( Fonction ){
				
				// Si la fonction n'est pas un objet —— - -
				if( !TypeOf( Fonction , "Object" ) ){
					
					// Convertie la fonction
					Fonction = { Fonction:Fonction };
				}
				
				// Ajoute l'asynchronisme à la fonction
				Fonction.Asynchrone = true;
			}
			
			// Convertie les guillemets
			Contenu = CharacterConversion( Contenu , "'" , "\\'" );
			Objet = CharacterConversion( Objet , "'" , "\\'" );
			
			// Convertie les caractères spéciaux —— - -
			for( var iSpe:int = 0 ; iSpe < StandardCharacterList.length ; iSpe++ ){
				//
				Contenu = CharacterConversion( Contenu , StandardCharacterList[ iSpe ][ 0 ] , StandardCharacterList[ iSpe ][ 1 ] );
				Objet = CharacterConversion( Objet , StandardCharacterList[ iSpe ][ 0 ] , StandardCharacterList[ iSpe ][ 1 ] );
			}
			
			// Construit le code
			var Code:Array = [   "Mail( '" + Contact + "' , '" + 
										 Objet + "' , '" + 
										 Contenu + "' , " + 
									     "{ " + 
										   ( ( Parametres.FromNom ) ? 
											 ( "FromNom:'" + Parametres.FromNom + "'" ) 
											 : "FromNom:null" ) + " , " + 
										   //
										   ( ( Parametres.FromMail ) ? 
											 ( "FromMail:'" + Parametres.FromMail + "'" ) 
											 : "FromMail:null" ) + " , " + 
										   //
										   ( ( Parametres.Reply ) ? 
											 ( "Reply:'" + Parametres.Reply + "'" )
											 : "Reply:null" ) + " , " + 
										   //
										   ( ( Parametres.LienPhp ) ? 
											 ( "LienPhp:'" + Parametres.LienPhp + "'" ) 
											 : "LienPhp:'" + Link_PHPcybORg + "'" ) + " , " + 
										   //
										   ( ( Parametres.Html ) ? 
											 ( "Html:" + Parametres.Html )
											 : "Html:false" ) + 
										   //
										 " } , " +
										 "this , " + 
										 "'JSSendRetourFonction' );"
							   ];
			
			
			
			// Active le code Javascript
			JSSend( Code , Fonction );
		}
		
		
		
		/* —————————————————————————————————————————— - - PRE-COMPILATION - - —————————————————————————————————————————— */
		// Les méthodes retournant du code JavaScript pré-compilé
		//*—*//
		
		// —————— JS PRECOM
	  	// Ensembles de méthodes générant du code pré-compilés en JavaScript pour une utilisation d'envoie
	 	//
	  	// —————— RETURN
	  	// Code pour lancer une fonction sous Flash
		public function JSPrecom_Return( Fonction:String ,		// ———— - - Nom de la fonction à déclancher
										 Argument:String = ""	// ———— - - Argument à transmettre s'il y en a
									   ):String {
			/*—*/
			//
			var Sortie:String = "( ( navigator.appName.indexOf( \"Microsoft\" ) != -1 ) ? window[ \"" + SceneName + "\" ] : document[ \"" + SceneName + "\" ] )" + 
								"." + Fonction + "( " + Argument + " );";
			//
			return Sortie;
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 PHP					  		  					  */
		/*										 Connexion avec du code Php 					  				  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables utilisées pour les méthodes de cet ensemble
		//*—*//
		
		// —————— LINK - M3K4
		// Le lien vers le script mEkA
		public var Link_mEkA:String = "";
		
		// —————— DB DATA
		// Les informations pour sa liaison Base de donnée
		public var DBData:Object = { Hebergeur:"localhost" , 
										   Login:"root" , 
										   Mdp:"" 
										 };
		
		// —————— M3K4 SCRIPT LIST
		// Liste des scripts mEkA
		private var mEkAScriptList:Object = { Link:"PaperTools" , 
										 Global:"MiscTools" 
									   };
		
		// —————— STANDARD CHARACTER LIST
		// Tableau des caractères spéciaux
		private var StandardCharacterList:Array =  [ [ "é" , "-e1-" ] ,
												  [ "è" , "-e2-" ] ,
												  [ "ê" , "-e3-" ] ,
												  [ "ë" , "-e4-" ] ,
												  [ "à" , "-a1-" ] ,
												  [ "â" , "-a2-" ] ,
												  [ "ä" , "-a3-" ] ,
												  [ "ù" , "-u1-" ] ,
												  [ "û" , "-u2-" ] ,
												  [ "ü" , "-u3-" ] ,
												  [ "ô" , "-o1-" ] ,
												  [ "É" , "-E1-" ] ,
												  [ "È" , "-E2-" ] ,
												  [ "Ê" , "-E3-" ] ,
												  [ "Ë" , "-E4-" ] ,
												  [ "À" , "-A1-" ] ,
												  [ "Â" , "-A2-" ] ,
												  [ "Ä" , "-A3-" ] ,
												  [ "Û" , "-U1-" ] ,
												  [ "Ü" , "-U2-" ] ,
												  [ "Ô" , "-O1-" ] ,
												  [ "œ" , "-oe-" ]
												 ];
		
		// —————— DB CHARACTER LIST
		// Tableau des caractères spéciaux de base de donnée
		private var DBCharacterList:Array = [ [ "ooSPACEoo" , "ooAROBAZoo" , "ooDOLLARoo" ] , 
														 [ " " , 		 "@" , 			"$" ] 
													   ];
		
		
		
		/* —————————————————————————————————————————— - - EMISSION - - —————————————————————————————————————————— */
		// Les méthodes pour communiquer avec des page Php
		//*—*//
		
		// —————— PHP SEND
	  	// Transmet, simplement, des données POST à une page en PHP
	  
		public function PHPSend( Lien:String = "" ,			// ———— - - Page PHP faisant le transfert
								 Envoie:* = null ,			// ———— - - Variables à envoyer en POST 
								 Post:* = null ,			// ———— - - Données liées au post-chargement
								 Erreur:* = null ,			// ———— - - Données liées à l'erreur de chargement
								 TypePage:String = "php"	// ———— - - Le type de page au cas où ce ne soit pas une page PHP
								):void {
			/*—*/
			
			// —— - - VARIABLES ◄◄ //
			//
			Envoie = Envoie || new Object();
			//
			Lien = ( Lien == "" ) ? Link_PHPcybORg : Lien;
			//
			var Instant:Object = new Object();
			
			// Créait les variables pour transmettre et contenir les éléments envoyés en POST
			var loader:URLLoader = new URLLoader();
			var monPOST:URLVariables = new URLVariables();
			
			
			// —— - - CONVERSION ◄◄ //
			//
			for( var Element in Envoie ){
				//
				Envoie[ Element ] = Envoie[ Element ].split( "\"" ).join( "-GUILLEMET-" );
			}
			
			// S'il y a une attente de réponse sans écho dans le code
			if( Envoie.Code && Post ){
				//
				if( !FindIn( Envoie.Code , "echo" ) ){
					
					// Rajoute un echo pour rien à la fin
					Envoie.Code += "\r" + "echo( \"OK\" );" + "\r";
				}
			}
			
			// Convertie le code s'il y en a un —— - -
			if( Envoie.Code ){
				//
				Envoie.Code = CharacterConversion( Envoie.Code , 
												 [ "\"" , "[" , "]" ] , 
												 [ "-GUILLEMET-" , "-Crochet1-" , "-Crochet2-" ] );
			}
			
			
			// —— - - REQUETE URL ◄◄ //
			//
			// Établie la liaison avec la page Php
			var request:URLRequest = new URLRequest( Lien + "." + TypePage );
			//
			// Établie le mode de liaison : POST
			request.method = URLRequestMethod.POST;
			//
			
			//
			// Définit les variables POST
			SetAll( monPOST , Envoie );
			//
			// Donne les variables POST
			request.data = monPOST;
			
			
			// —— - - FONCTIONS ◄◄ //
			//
			// Fonction à lancer une fois le chargement achevé —— - -
			Instant.Achevee = function( Evt:Event ){
				//
				if( !Launch( Post , true , Evt.target.data ) ){
					//
					Launch( Post ); 
				}
			}
			// Fonction à lancer en cas d'erreur —— - -
			Instant.Erreur = function( Evt:IOErrorEvent ){
				//
				Launch( Erreur );
			}
			//
			loader.dataFormat = URLLoaderDataFormat.TEXT;
			//
			// Donne l'écouteur à l'élément loadeur pour lorsqu'il sera achevé
			AddEvents( loader , Instant.Achevee , "COMPLETE" );
			AddEvents( loader , Instant.Erreur , "IO_ERROR" );
			
			
			// —— - - LANCEMENT ◄◄ //
			// 
			// Lance le chargement de la requête —— - -
			try { loader.load( request );
			
			// S'il y a une erreur —— - -
			} catch ( e ) {
				
				// S'il y a une cible définit pour le retour —— - - Lance sa fonction
				Launch( Erreur );
			}
		}
	  
	  
		// —————— PHP EVAL
	  	// Appel une page PHP par lien Url et lui transmet des valeur en Post et Get.
	  	// Par défaut, elle appelle une page Php prévue pour compiler ce qu'on lui transmet en Get dans un éval
	  
		public function PHPEval( POST:* = null ,			// ———— - - Variables à envoyer en POST 
								 GET:* = null ,				// ———— - - Variables à envoyer en GET 
								 Post:* = null ,			// ———— - - Données liées au post-chargement
								 Erreur:* = null ,			// ———— - - Données liées à l'erreur de chargement
								 Type:Object = null ,		// ———— - - Le typing du transfert ( Deux clés : Type et Appli )
								 Lien:String = "link" ,		// ———— - - Page PHP faisant le transfert
								 TypePage:String = "php"	// ———— - - Le type de page au cas où ce ne soit pas une page PHP
								):void {
			/*—*/
			
			// Compile le type s'il y en a un —— - -
			if( Type ){
				//
				var EnTete:URLRequestHeader = new URLRequestHeader( Type.Type , Type.Appli );
			}
			
			// Verifie le get s'il y en a —— - -
			if( GET ){
				
				// Pour chaque clé —— - -
				for( var iGet in GET ){
					//
					// S'il s'agit du code —— - - Le compile
					if( iGet == "Code" ){ GET[ iGet ] = StringToName( GET[ iGet ] ); }
				}
			}
			
			// Compile le lien avec les get
			var Requete:URLRequest = new URLRequest( Link_MIND + ( Link_MIND != "" ? "/" : "" ) + Lien + "." + TypePage +
													 ( ( GET != null ) ? "?" + ObjectToGet( GET ) : "" ) );
			
			// Fournit les données nécessaire pour la page php
			if( Type ){
				//
				Requete.requestHeaders.push( EnTete );
			}
			
			// Vérifie et donne le Post
			if( POST ){
				//
				Requete.method = URLRequestMethod.POST;
				Requete.data = POST;
			}
			
			// Lance le lien
			navigateToURL( Requete , "_blank" );
		}
		
		
		
		/* —————————————————————————————————————————— - - EMISSION XML - - —————————————————————————————————————————— */
		// Les méthodes pour communiquer avec des fichiers Xml
		//*—*//
		
		// —————— PHP UPLOAD XML
	  	// Upload un fichier Xml, nouveau ou déjà éxistant
	  	//
	  	// ◘34◘ — mEkA Need
	  	// La liaison avec mEkA doit être établie par le biais de la variable lien vers mEkA pour que cette méthode fonctionne
	  
		public function PHPUploadXML( Nom:String = "NouveauXml" ,	// ———— - - Nom du fichier Xml créé ou modifié
									  Dossier:String = "" ,			// ———— - - Dossier où est placé le fichier Xml
									  Envoie:* = null ,				// ———— - - Code de compilation du Xml ( Par [1], etc. )
									  Post:* = null ,				// ———— - - Données liées au post-chargement
									  Erreur:* = null				// ———— - - Données liées à l'erreur de chargement
									 ):void {
			/*—*/
			
			// Créait la variable de code PHP
			var CodePHP:String = "";
			
			// Donne au code PHP le chargement des deux scripts nécessaires
			CodePHP += PHPPrecom_ScriptmEkA( "MiscTools" , "Global" );
			CodePHP += PHPPrecom_ScriptmEkA( "PaperTools" , "Link" );
			
			// Intégre le code de compilation du Xml à partir de la chaine de caractère transmise
			CodePHP += "FullXml( \"" + Envoie + 
								"\" , \"" + Nom + 
								"\" , \"" + Link_PHPcybORgRoot + "\" );" + "\r";
			
			// Lance le code en PHP
			PHPSend( "" , { Code:CodePHP } , Post , Erreur );
		}
	  
	  
		// —————— PHP UPLOAD XML OBJECT
	  	// Upload un fichier Xml, nouveau ou déjà éxistant, à partir d'un objet qui deviendra cet Xml
	  	//
	  	// ◘34◘ — mEkA Need
	  	// La liaison avec mEkA doit être établie par le biais de la variable lien vers mEkA pour que cette méthode fonctionne
	  
		public function PHPUploadXMLObject( Objet:Object ,				// ———— - - Objet devenant le Xml
											Nom:String = "NouveauXml" ,	// ———— - - Nom du fichier Xml créé ou modifié
											Dossier:String = "" ,		// ———— - - Dossier où est placé le fichier Xml
											Post:* = null ,				// ———— - - Données liées au post-chargement
											Erreur:* = null				// ———— - - Données liées à l'erreur de chargement
										  ):void {
			/*—*/
			
			// Lance l'upload Xml à partir de l'objet convertie en String
			PHPUploadXML( Nom , Dossier , PHPPrecom_XMLObject( Objet ) , Post , Erreur );
		}
	  
	  
		// —————— PHP CHANGE XML
	  	// Modifie un Xml en transmettant les modifications à effectuer au Php. 
		// Bien plus rapide et optimisé que la méthode PhpChangeXmlHere().
	  	//
	  	// ◘34◘ — mEkA Need
	  	// La liaison avec mEkA doit être établie par le biais de la variable lien vers mEkA pour que cette méthode fonctionne
	  
		public function PHPChangeXML( Nom:String ,					// ———— - - Nom du fichier Xml modifié
									  Dossier:String = "" ,			// ———— - - Dossier où est placé le fichier Xml
									  Modifications:* = null , 		// ———— - - Les modifications appliqués aux noeuds du Xml
									  Post:* = null ,				// ———— - - Fonction liée au post-chargement
									  Erreur:* = null				// ———— - - Fonction liée à l'erreur de chargement
								  ):void {
			/*—*/
			
			// Créait la variable de code PHP
			var CodePHP:String = "";
			
			// Donne au code PHP le chargement des deux scripts nécessaires
			CodePHP += PHPPrecom_ScriptmEkA( "MiscTools" , "Global" );
			CodePHP += PHPPrecom_ScriptmEkA( "PaperTools" , "Link" );
			
			// Créait le code de modification
			var CodePHPModification:String = " array( ";
			
			// Pour chaque Modifications —— - -
			for( var iModif:int = 0 ; iModif < Modifications.length ; iModif++ ){
				
				// Ajoute le tableau
				CodePHPModification += " array( ";
				
				// Ajoute les données de modification
				CodePHPModification += "\"" + Modifications[ iModif ].Chemin + "\" , ";
				CodePHPModification += "\"" + Modifications[ iModif ].Valeur + "\"";
				//
				if( Modifications[ iModif ].Modification ){ CodePHPModification += " , \"" + Modifications[ iModif ].Modification + "\""; }
				
				// Termine le tableau
				CodePHPModification += " )";
				
				// Ajoute la virgule s'il le faut
				if( iModif != Modifications.length - 1 ){
					//
					CodePHPModification += " ,";
				}
			}
				
			// Fin de tableau
			CodePHPModification += ")";
			
			// Intégre le code de compilation du Xml à partir de la chaine de caractère transmise
			CodePHP += "MultiModifXml( \"" + Nom + "\" , " + CodePHPModification + 
													 " , \"" + ( ( Dossier != "" ) ? Link_PHPcybORgRoot + "/" + Dossier : Link_PHPcybORgRoot ) + "\" );";
			
			// Lance le code en PHP
			PHPSend( "" , { Code:CodePHP } , Post , Erreur );
		}
	  
	  
		// —————— PHP CHANGE XML HERE
	  	// Modifie un contenu de fichier Xml en le chargeant, modifiant puis ré-uploadant
	  	//
	  	// ◘34◘ — mEkA Need
	  	// La liaison avec mEkA doit être établie par le biais de la variable lien vers mEkA pour que cette méthode fonctionne
	  
		public function PHPChangeXMLHere( Nom:String ,					// ———— - - Nom du fichier Xml modifié
									      Dossier:String = "" ,			// ———— - - Dossier où est placé le fichier Xml
										  Modifications:* = null , 		// ———— - - Les modifications appliqués aux noeuds du Xml ( Sous forme de string )
									      Post:* = null ,				// ———— - - Fonction liée au post-chargement
									      Erreur:* = null ,				// ———— - - Fonction liée à l'erreur de chargement
										  Traitement:* = null			// ———— - - Fonction liée au traitement en court
									     ):void {
			/*—*/
			
			// Créait l'objet et la fonction de réception
			var ObjetReception:Object = new Object();
			//
			// Fonction de réception, traitement et renvoie du Xml —— - -
			ObjetReception.Reception = function( ObjetXml:Object ):void {
				
				// lance la fonction liée au traitement en court
				Launch( Traitement );
				
				// Modifie l'objet Xml
				TotalChangeObject( ObjetXml , Modifications );
				
				// Lance le ré-upload du fichier Xml
				PHPUploadXMLObject( ObjetXml , Nom , Dossier , Post , Erreur );
			}
			//
			// Fonction d'erreur —— - -
			ObjetReception.Erreur = function( SortieErreur:* = null ):void {
				
				// Lance la fonction erreur
				Launch( Erreur );
			}
			
			// Initialise le Paper
			var Paper:PaperTools = new PaperTools();
			
			// Lance le chargement du Xml
			Paper.XMLLoad( Nom ,
						  {
							  fonctionEnd:{
											Cible:ObjetReception ,
											Fonction:"Reception" ,
											Traitement:"MorphingObject"
										 } ,
							  fonctionError:{
												Cible:ObjetReception ,
												Fonction:"Erreur"
											 }
						  }
					  );
		}
		
		
		
		/* —————————————————————————————————————————— - - EMISSION DB - - —————————————————————————————————————————— */
		// Les méthodes pour communiquer avec des bases de données
		//*—*//
		
		// —————— PHP CHECK DB
	  	// Charge une base de donnée pour en retirer des suites de variables
	  	//
	  	// ◘34◘ — mEkA Need
	  	// La liaison avec mEkA doit être établie par le biais de la variable lien vers mEkA pour que cette méthode fonctionne
	  
		public function PHPCheckDB( Base:String  ,		// ———— - - La Base connectée
								    Table:String  ,		// ———— - - La Table ciblée
								    Elements:* = null ,	// ———— - - Les Collones à fouiller
								    Post:* = null ,		// ———— - - Données liées au post-chargement
								    Erreur:* = null		// ———— - - Données liées à l'erreur de chargement
								  ):void {
			/*—*/
			
			// Arguments par défaut
			Elements = Elements || new Object();
			
			// Créait la variable de code PHP
			var CodePHP:String = "";
			
			// Donne au code PHP le chargement des deux scripts nécessaires
			CodePHP += PHPPrecom_ScriptmEkA( "MiscTools" , "Global" );
			CodePHP += PHPPrecom_ScriptmEkA( "BookLink" , "Link" );
			
			
			// Créait l'objet et sa fonction de retour
			var ObjetRetour:Object = new Object();
			//
			ObjetRetour.Retour = function( Sortie:String ):void {
				
				// Convertie la sortie en objet
				var ObjetSortie:Object = new Object();
				var TableauSortie:Array = Sortie.split( "xxETxx" );
				//
				TableauSortie.shift();
				//
				for( var j:int = 0 ; j < TableauSortie.length ; j++ ){
					//
					var NomSortie:String = TableauSortie[ j ].split( "xxEGALxx" )[ 0 ];
					ObjetSortie[ NomSortie ] = TableauSortie[ j ].split( "xxEGALxx" )[ 1 ].split( "xxSEPARExx" );
					
					// Pour chaque élément récupéré —— - -
					for( var k:int = 0 ; k < ObjetSortie[ NomSortie ].length ; k++ ){
						//
						// Reconvertie ses espaces
						ObjetSortie[ NomSortie ][ k ] = CharacterConversion( ObjetSortie[ NomSortie ][ k ] , 
																			 DBCharacterList[ 0 ] , 
																			 DBCharacterList[ 1 ] )
					}
				}
				
				// Lance la fonction de sortie
				Launch( Post , true , ObjetSortie );
			}

			
			// Intégre le code de connexion à la Base de donnée
			CodePHP += "ConnexionDataBase( \"" + Base + 
									 "\" , \"" + DBData.Hebergeur + 
									 "\" , \"" + DBData.Login + 
									 "\" , \"" + DBData.Mdp + 
									 "\" , " + "Retour" + " );" + "\r\r";
			
			// Intégre le code de connexion à la Base de donnée
			CodePHP += "function Retour(){ " + "\r"
			CodePHP += "$Sortie = \"\";" + "\r";
			
			// Pour chaque éléments à chercher —— - -
			for( var i:* in Elements ){
				
				// Le convertie en objet s'il n'en est pas un —— - -
				if( !TypeOf( Elements[ i ] , "Object" ) ){ 
					//
					Elements[ i ] = new Object();
				}
				
				// Ajoute la méthode pour cet élément récupérant les données dans le tableau
				CodePHP += "$Recuperation = SelectionData( \"" + Table + "\" , \"" + i + "\""
				
				// Rajoute ses arguments altérnatifs
				CodePHP += ( Elements[ i ].Cible ) ? ", array(" + Elements[ i ].Cible + ")" : "";
				CodePHP += ( Elements[ i ].Ordre ) ? ", array(" + Elements[ i ].Ordre + ")" : "";
				
				// Cloture de la méthode
				CodePHP += " );" + "\r";
				
				// Conversion du tableau sissue de la méthode
				CodePHP += "$Sortie .= \"xxETxx\" . \"" + i + "\" . \"xxEGALxx\" . join( \"xxSEPARExx\" , $Recuperation );" + "\r";
			}
			
			// Écho de sortie
			CodePHP += "echo $Sortie;" + "\r";
								
			// Fin de la méthode passé l'ouverture base de donnée
			CodePHP += "}" + "\r";
			
			// Lance le code en PHP
			PHPSend( "" , { Code:CodePHP } , ObjetRetour.Retour , Erreur );
		}
	  
	  
		// —————— PHP INSERT DB
	  	// Ajoute des données à une base de donnée
	 	//
	  	// ◘34◘ — mEkA Need
	  	// La liaison avec mEkA doit être établie par le biais de la variable lien vers mEkA pour que cette méthode fonctionne
	  
		public function PHPInsertDB( Base:String  ,			// ———— - - La Base connectée
								     Table:String  ,		// ———— - - La Table ciblée
								     Elements:* = null ,	// ———— - - Les Éléments à rajouter ( Soit un objet avec les clés, soit un tableau d'objet )
								     Post:* = null ,		// ———— - - Données liées au post-chargement
								     Erreur:* = null		// ———— - - Données liées à l'erreur de chargement
								   ):void {
			/*—*/
			
			// Arguments par défaut
			Elements = CapsuleArray( Elements );
			
			// Créait la variable de code PHP
			var CodePHP:String = "";
			
			// Donne au code PHP le chargement des deux scripts nécessaires
			CodePHP += PHPPrecom_ScriptmEkA( "MiscTools" , "Global" );
			CodePHP += PHPPrecom_ScriptmEkA( "BookLink" , "Link" );
			
			// Intégre le code de connexion à la Base de donnée
			CodePHP += "ConnexionDataBase( \"" + Base + 
									 "\" , \"" + DBData.Hebergeur + 
									 "\" , \"" + DBData.Login + 
									 "\" , \"" + DBData.Mdp + 
									 "\" , " + "Retour" + " );" + "\r\r";
			
			// Intégre le code de connexion à la Base de donnée
			CodePHP += "function Retour(){ " + "\r"
			
			// Pour chaque éléments à rajouter —— - -
			for( var j:int = 0 ; j < Elements.length ; j++ ){
					
				// Ajoute la méthode pour cet élément ajoutant des éléments à la base de donnée
				CodePHP += "AjoutData( \"" + Table + "\" , array( ";
				
				// Récupère son nombre de clé
				var leNombreClees:int = LengthObject( Elements[ j ] );
				
					// Pour chaque éléments de l'élement à rajouter —— - -
					for( var i:* in Elements[ j ] ){
						
						// Rajoute ses arguments de contenu
						CodePHP += "array( \"" + i + "\" , \"" + CharacterConversion( Elements[ j ][ i ] , 
																					  DBCharacterList[ 1 ] , 
																					  DBCharacterList[ 0 ] ) + "\" )";
						
						// Réduit le nombre de clée restantes
						leNombreClees--;
						
						// Si ce n'est pas la dernière —— - - ajoute une virgule
						if( leNombreClees > 0 ){ CodePHP += " , "; }
					}
				
				// Cloture de la méthode
				CodePHP += " ) );" + "\r";
			}
								
			// Retour
			CodePHP += "echo \"OK\";" + "\r";
								
			// Fin de la méthode passé l'ouverture base de donnée
			CodePHP += "}" + "\r";
			
			// Lance le code en PHP
			PHPSend( "" , { Code:CodePHP } , Post , Erreur );
		}
	  
	  
		// —————— PHP DELETE DB
	  	// Supprime des données à une base de donnée
	  	//
	  	// ◘34◘ — mEkA Need
	  	// La liaison avec mEkA doit être établie par le biais de la variable lien vers mEkA pour que cette méthode fonctionne
	  
		public function PHPDeleteDB( Base:String  ,			// ———— - - Base connectée
								     Table:String  ,		// ———— - - La table ciblée
								     Elements:* = null ,	// ———— - - Élément de reconnaissance ( Objet à string )
								     Post:* = null ,		// ———— - - Données liées au post-chargement
								     Erreur:* = null		// ———— - - Données liées à l'erreur de chargement
								   ):void {
			/*—*/
			
			// Créait la variable de code PHP
			var CodePHP:String = "";
			
			// Donne au code PHP le chargement des deux scripts nécessaires
			CodePHP += PHPPrecom_ScriptmEkA( "MiscTools" , "Global" );
			CodePHP += PHPPrecom_ScriptmEkA( "BookLink" , "Link" );
			
			// Intégre le code de connexion à la Base de donnée
			CodePHP += "ConnexionDataBase( \"" + Base + 
									 "\" , \"" + DBData.Hebergeur + 
									 "\" , \"" + DBData.Login + 
									 "\" , \"" + DBData.Mdp + 
									 "\" , " + "Retour" + " );" + "\r\r";
			
			// Intégre le code de connexion à la Base de donnée
			CodePHP += "function Retour(){ " + "\r"
			
			// Pour chaque clé unique de l'objet ( Il ne doit en avoir qu'une )
			for( var i:* in Elements ){
				
				// Ajoute la méthode pour détruire les éléments relatifs
				CodePHP += "SupprimeData( \"" + Table + "\" , array( " + CharacterConversion( i , " " , "ooSPACEoo" ) + " , " 
																	   + CharacterConversion( Elements[ i ] , 
																							  DBCharacterList[ 1 ] , 
																							  DBCharacterList[ 0 ] ) + " ) );" + "\r";
			}
								
			// Retour
			CodePHP += "echo \"OK\";" + "\r";
								
			// Fin de la méthode passé l'ouverture base de donnée
			CodePHP += "}" + "\r";
			
			// Lance le code en PHP
			PHPSend( "" , { Code:CodePHP } , Post , Erreur );
		}
	  
	  
		// —————— PHP UPLOAD DB
	  	// Modifie des données d'une base de donnée
	  	//
	  	// ◘34◘ — mEkA Need
	  	// La liaison avec mEkA doit être établie par le biais de la variable lien vers mEkA pour que cette méthode fonctionne
	  
		public function PHPUploadDB( Base:String  ,			// ———— - - Base connectée
									 Table:String  ,		// ———— - - La table ciblée
									 Elements:* = null ,	// ———— - - Élément de reconnaissance 
									 						//			( Objet contenant des objet à deux clé Valeur et Elements )
									 Post:* = null ,		// ———— - - Données liées au post-chargement
									 Erreur:* = null		// ———— - - Données liées à l'erreur de chargement
								   ):void {
			/*—*/
			
			// Créait la variable de code PHP
			var CodePHP:String = "";
			
			// Donne au code PHP le chargement des deux scripts nécessaires
			CodePHP += PHPPrecom_ScriptmEkA( "MiscTools" , "Global" );
			CodePHP += PHPPrecom_ScriptmEkA( "BookLink" , "Link" );
			
			// Intégre le code de connexion à la Base de donnée
			CodePHP += "ConnexionDataBase( \"" + Base + 
									 "\" , \"" + DBData.Hebergeur + 
									 "\" , \"" + DBData.Login + 
									 "\" , \"" + DBData.Mdp + 
									 "\" , " + "Retour" + " );" + "\r\r";
			
			// Intégre le code de connexion à la Base de donnée
			CodePHP += "function Retour(){ " + "\r"
			
			// Pour chaque clé unique de l'objet ( Il ne doit en avoir qu'une )
			for( var i:* in Elements ){
				
				// Ajoute la méthode pour détruire les éléments relatifs
				CodePHP += "ModifieData( \"" + Table + "\" , array( ";
				
				// Récupère le nombre de clés
				var leNombreClees:int = LengthObject( Elements[ i ].Elements );
				
				// Pour chaque clé dans les éléments —— - -
				for( var j:* in Elements[ i ].Elements ){
					
					// Ajoute les données
					CodePHP += "array( \"" +
							  CharacterConversion( j , DBCharacterList[ 1 ] , DBCharacterList[ 0 ] ) + "\" , \"" +
							  CharacterConversion( Elements[ i ].Elements[ j ] , 
												    DBCharacterList[ 1 ] , 
												    DBCharacterList[ 0 ] ) + "\" )";
							   
					// Réduit le nombre de clés restantes
					leNombreClees--;
					
					// S'il en reste —— - - Ajoute la virgule
					if( leNombreClees > 0 ){ CodePHP += " , "; }
				}
				
				// Termine la chaine
				CodePHP += " ) , array( \"" + CharacterConversion( i , " " , "ooSPACEoo" ) + "\" , \"" 
														   + CharacterConversion( Elements[ i ].Valeur , 
																				  DBCharacterList[ 1 ] , 
																				  DBCharacterList[ 0 ] ) + "\" ) );" + "\r";
			}
								
			// Retour
			CodePHP += "echo \"OK\";" + "\r";
								
			// Fin de la méthode passé l'ouverture base de donnée
			CodePHP += "}" + "\r";
			
			// Lance le code en PHP
			PHPSend( "" , { Code:CodePHP } , Post , Erreur );
		}
		
		
		
		/* —————————————————————————————————————————— - - PRE-COMPILATION - - —————————————————————————————————————————— */
		// Les méthodes retournant du code Php pré-compilé
		//*—*//
		
		// —————— PHP PRECOM
	  	// Ensembles de méthodes générant du code pré-compilés en PHP pour une utilisation d'envoie
	  	//
	  	// —————— SCRIPT M3K4
	  	// Code pour charger un script mEkA
		public function PHPPrecom_ScriptmEkA( NomScript:String = "" ,		// ———— - - Le Nom du script
											  TypeScript:String = "Global" 	// ———— - - Le Type du script
										     ):String {
			/*—*/
			
			// S'il y a un nom de script —— - -
			if( NomScript != "" ){
				
				// Retourne le code pour ce script
				return "require_once( \"" + ( ( Link_mEkA != "" ) ? Link_mEkA + "/" : "" ) + "mEkA/" + 
												TypeScript + "/" + NomScript + ".inc.php\" );" + "\r";
				
			// S'il n'y a pas de nom de script —— - -
			} else {
				
				// Créait la vériable de sortie
				var Sortie:String = "";
				
				// Pour chaque élément de mEkA —— - -
				for( var Element in mEkAScriptList ){
					
					// Ajoute le code pour le lancement
					Sortie += "require_once( \"" + ( ( Link_mEkA != "" ) ? Link_mEkA + "/" : "" ) + "mEkA/" + 
													   Element + "/" + mEkAScriptList[ Element ] + ".inc.php\" );" + "\r";
				}
				
				// Retourne la sortie
				return Sortie;
			}
		}
	  	//
	  	// —————— XML OBJECT
	  	// Convertie un objet en chaine de caractère permettant la génération d'un Xml par mEkA
		public function PHPPrecom_XMLObject( Objet:Object ,		// ———— - - L'Objet concerné
											 Niveau:int = 1		// ———— - - Niveau de parcours en cours
										   ):String {
			/*—*/
			
			// Création de la variable de sortie
			var Sortie = "";
			
			// Pour chaque élément de l'objet —— - -
			for( var Element:* in Objet ){
				
				// S'il n'est pas null —— - -
				if( Objet[ Element ] != null ){
					
					// S'il ne s'agit ni du contenu, ni de parametres —— - -
					if( Element != "Contenu" && Element != "Parametres" ){
						
						// Ajoute le séparateur de niveau si ce n'est pas le tout premier
						if( Sortie != "" ){
							//
							// Et en prévenant les redondance
							if( Sortie.split( "[" + Niveau + "]" )[ Sortie.split( "[" + Niveau + "]" ).length - 1 ] != ""
							  || Sortie.split( "[" + Niveau + "]" ).length == 1 ){
	
								Sortie += "[" + Niveau + "]";
							}
						}
						
						// Ajoute le nom de la clé
						Sortie += Element;
						
						// Si sa valeur n'est pas un objet —— - -
						if( !TypeOf( Objet[ Element ] , "Object" ) ){
							
							// Ajoute sa valeur comme contenu
							Sortie += "->" + Objet[ Element ];
							
						// S'il est un objet possédant la clé "Contenu" —— - -
						} else {
							
							// S'il posséde la clé "Parametres" —— - -
							if( Objet[ Element ].Parametres ){
								
								// Ajoute le transfert de parametres
								Sortie += "=>";
								
								// Pour chaque parametre —— - -
								var iParam:int = 0;
								//
								for( var Param:* in Objet[ Element ].Parametres ){
									//
									// Ajoute le nom du parametre et sa valeur
									Sortie += ( ( iParam != 0 ) ? "&" : "" ) + Param + "=" + Objet[ Element ].Parametres[ Param ];
									//
									iParam++;
								}
							}
							
							// S'il posséde la clé "Contenu" —— - -
							if( Objet[ Element ].Contenu ){
								
								// Ajoute la valeur de la clé "Contenu" comme contenu
								Sortie += "->" + Objet[ Element ].Contenu;
							} 
						}
						
						// Ajoute le séparateur de niveau s'il n'y en a pas déjà un à la fin
						// Et en prévenant les redondance
						if( Sortie.split( "[" + Niveau + "]" )[ Sortie.split( "[" + Niveau + "]" ).length - 1 ] != ""
						  || Sortie.split( "[" + Niveau + "]" ).length == 1 ){
	
							Sortie += "[" + Niveau + "]";
						}
	
						
						// S'il s'agit d'un objet —— - -
						if( TypeOf( Objet[ Element ] , "Object" ) ){
							
							// Relance la compilation du nom sur le niveau suivant
							Sortie += PHPPrecom_XMLObject( Objet[ Element ] , Niveau + 1 );
						}
					}
				}
			}
			
			// Renvoie le tout
			return Sortie;
		}
		
		
		
		
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}