﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			PICTURE COMPILER	  	Version 0.1.0									***/
/***				   				   Dernière Mise à Jour : 10-09-10										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         			  Plug - Compilateur d'images										***/
/***	Ce script contient les méthodes en communications avec les scripts d'ajouts concernant la gestion   ***/
/***	des images et BitmapData.																			***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Plug.images {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	 
	// —— - - DISPLAY
	import flash.display.MovieClip;
	 //
	// —— - - PLUG
	import drOIde.Plug.images.JPGEncoder;
	import drOIde.Plug.images.PNGEncoder;
	import drOIde.Plug.images.BitString;
	//
	// —— - - UTILS
	import flash.utils.*;
	//
	// —— - - PLUG
	import flash.display.BitmapData;
	//
	// —— - - URL
	import flash.net.URLRequest;
	import flash.net.URLRequestHeader;
	import flash.net.URLRequestMethod;
	import flash.net.navigateToURL;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	import drOIde.Link.WebLink;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class PictureCompiler extends MiscTools {
		
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*												   				  										  */
	/*				 	      					  VARIABLES GLOBALES										  */
	/*		  							 Les variables d'utilisations globales								  */
	/*												   				  										  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		//*——*//
		
		// —————— ENCODER
		// Les deux éléments d'encodage
		var JPG:* = JPGEncoder;
		var PNG:* = PNGEncoder;
		
		
		// —————— LINK
		// Lien vers des scripts drOIde externes
		var Web:WebLink;
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function PictureCompiler( TheLink	// ———— - - Lien vers la scène
									):void {
			/*—*/
			
			// Établie la connexion
			Connexion( TheLink );
			
			// Création du WebLink en lien avec la scène
			Web = new WebLink( TheLink )
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 SAVE					  		  					  */
		/*								Compiler et sauvegarder les images ( Sur Internet ) 					  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - SAVE - - —————————————————————————————————————————— */
		// Les méthodes pour sauvegarder des images
		//*—*//
		
		// ——————  SHOT AND SAVE
		// Fait une capture du contenu d'un clip et l'enregistre sur un dossier du site
		// Concernant la clé "process" des Parametres : "Save" : Enregistrer ; Un nom de dossier : la mettre sur le serveur du site
		
		public function ShotAndSave( Source:* ,					// ———— - - Clip contenant le visuel
									 Nom:String = "monImage" ,	// ———— - - Nom à donner à l'image
									 Parametres:Object = null	// ———— - - Les Paramètres du traitement
									):void {
			/*—*/
			
			// Arguments par défaut
			Parametres = Parametres || new Object();
			
			// Calibrage des valeurs
			var Taille:Object = { width:Parametres.width , height:Parametres.height };
			var Format:String = Parametres.format || "jpg";
			var Procedure:String = Parametres.process || "Save";
			
			// Arguments et variables par défauts
			Taille.width = ( Taille.width != null && Taille.width != undefined ) ? Taille.width : Source.width;
			Taille.height = ( Taille.height != null && Taille.height != undefined ) ? Taille.height : Source.height;
			//
			var ScriptEncodage:* = This[ Format.toUpperCase() ];
			
			// Compile et dessine la variable BitmapData
			var NouvelleImage:BitmapData = new BitmapData( Source.width , Source.height );
			//
			NouvelleImage.draw( Source );

			// Encode l'image pour la sauvegarde
			var Encoder:* = new ScriptEncodage( 85 );
			var Stream:ByteArray = Encoder.encode( NouvelleImage );
			
			// Prépare le code PHP de traitement et sauvegarde de l'image
			var CodePHP:Array = ( Procedure == "Save" ) ?
								[ "if( isset( $GLOBALS[ \"HTTP_RAW_POST_DATA\" ] ) ) {" ,
								  "	   $Image = $GLOBALS[ \"HTTP_RAW_POST_DATA\" ];" ,
								  "	   header( 'Content-Type: image/" + ( Format == "jpg" ? "jpeg" : Format ) + "');" ,
								  "	   header( \"Content-Disposition: attachment; filename=\".$_GET[ 'name' ] );" ,
								  "    echo $Image;" ,
								  "	}" ] :
								[ "if ( isset( $GLOBALS[ \"HTTP_RAW_POST_DATA\" ] ) ) {" ,
								  "$Image = $GLOBALS[ \"HTTP_RAW_POST_DATA\" ];" ,
								  "file_put_contents( \"" + Procedure + ( Procedure != "" ? "/" : "" ) + Nom + "." + Format + "\", $Image);" ,
								  "	}" ];
			
			// Lance le lien à la page de Traitement PHP par URL
			Web.PHPLite( Stream , 
							 {
								 name:Nom + "." + Format ,
								 Code:CodePHP.join( "" )
							 } ,
							 null ,			
							 null ,	
							 { 
								Type:"Content-type" , 
								Appli:"application/octet-stream" 
							 }
							);
		}
		
		
		
	
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}