﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			 KEYBOARD PORT	  		Version 0.4.6									***/
/***				   				   Dernière Mise à Jour : 10-09-29										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         				  Portage Clavier												***/
/***	Ce script gére les appuies au clavier, il permet de tester les appuies de touche par le biais des   ***/
/***	numéros en ascii, du nom de la touche mais permet également d'attacher un appel de fonction avec 	***/
/***	un tableau d'argument à une touche afin qu'elle le lance avec le tableau comme argument à 		 	***/
/***	l'appuie.									      													***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Port {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	  
	// —— - - DISPLAY
	import flash.display.MovieClip;
	//
	// —— - - EVENTS
	import flash.events.KeyboardEvent;
	import flash.events.Event;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class KeyboardPort extends MiscTools {
		
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*												   				  										  */
	/*				 	      					  VARIABLES GLOBALES										  */
	/*		  							 Les variables d'utilisations globales								  */
	/*												   				  										  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		//*——*//
	  
		// —————— KEY STOCKING
		// Stockage des clées
		private var KeyStock:Object = new Object();
		private var KeyConvertList:Object = {  SPACE : 32,
											  SHIFT : 16 ,
											  CONTROL : 17,
											  
											  BACKSPACE : 8,
											  CAPS_LOCK : 20,
											  DELETE : 46,
											  ENTER : 13,
											  TAB : 9,
											  ESCAPE : 27,
											  INSERT : 45,
											  
											  HOME : 36,
											  END : 35,
											  PAGE_DOWN : 34,
											  PAGE_UP : 33,
											  
											  UP	: 38,
											  DOWN	: 40,
											  LEFT	: 37,
											  RIGHT : 39,
											  
											  F1 : 112,
											  F2 : 113,
											  F3 : 114,
											  F4 : 115,
											  F5 : 116,
											  F6 : 117,
											  F7 : 118,
											  F8 : 119,
											  F9 : 120,
											  F10 : 121,
											  F11 : 122,
											  F12 : 123,
											  F13 : 124,
											  F14 : 125,
											  F15 : 126,
											  
											  NUMPAD_0 : 96,
											  NUMPAD_1 : 97,
											  NUMPAD_2 : 98,
											  NUMPAD_3 : 99,
											  NUMPAD_4 : 100,
											  NUMPAD_5 : 101,
											  NUMPAD_6 : 102,
											  NUMPAD_7 : 103,
											  NUMPAD_8 : 104,
											  NUMPAD_9 : 105,
											  NUMPAD_ADD : 107,
											  NUMPAD_DIVIDE : 111,
											  NUMPAD_ENTER : 108,
											  NUMPAD_MULTIPLY : 106,
											  NUMPAD_SUBSTRACT : 109,
											  NUMPAD_DOT : 110,
											  
											  MAJ_0 : 48,
											  MAJ_1 : 49,
											  MAJ_2 : 50,
											  MAJ_3 : 51,
											  MAJ_4 : 52,
											  MAJ_5 : 53,
											  MAJ_6 : 54,
											  MAJ_7 : 55,
											  MAJ_8 : 56,
											  MAJ_9 : 57,
											  
											  A : 65,
											  Z : 90,
											  E : 69,
											  R : 82,
											  T : 84,
											  Y : 89,
											  U : 85,
											  I : 73,
											  O : 79,
											  P : 80,
											  Q : 81,
											  S : 83,
											  D : 68,
											  F : 70,
											  G : 71,
											  H : 72,
											  J : 74,
											  K : 75,
											  L : 76,
											  M : 77,
											  W : 87,
											  X : 88,
											  C : 67,
											  V : 86,
											  B : 66,
											  N : 78,
											  
											  Parenthese : 219,
											  Egale : 187,
											  Chapeau : 221,
											  Dollar : 186,
											  Pourcentage : 192,
											  Etoile : 220,
											  Virgule : 188,
											  PointVirgule : 190,
											  DeuxPoints : 191,
											  PointExclamation : 223
											  };
		
		// —————— HISTORIC
		// L'Historique des touches
		public var Historic:Array = new Array();
		
		// —————— LOCK
		// L'État de Locking
	  	public var LockActive:Boolean = false;
		public var Lock:Object = new Object();
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function KeyboardPort( TheLink:* = null 	// ———— - - Lien général de la scène
									 ):void {
			/*—*/
			
			// Si on a connecté le port —— - -
			if( Connexion( TheLink ) ){
				
				// Donne les touches à l'objet de Lock
				for( var iKey:* in KeyConvertList ){ 
					//
					Lock[ iKey ] = false; 
				}
				
				// Branchement du clavier pour reconnaissance de l'appuie et du relachement des touches
				AddEvents( StageLink , KeyDown , "KEY_DOWN" );
				AddEvents( StageLink , KeyUp , "KEY_UP" );
				
				
			// Si on a ommis de connecter le port —— - -
			} else {
				
				// Sort l'erreur
				TraceError( "KeyboardPort" , "Initialisation du KeyboardPort" , 
							[ "Vous devez donner un lien vers la scène comme dans l'exemple suivant :" ,
							  "var Keyboard:KeyboardPort = new KeyboardPort( this );" ]
							);
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 GLOBAL					  		  					  */
		/*							    Méthodes pour calibrer les valeurs du clavier 					  		  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - REACT - - —————————————————————————————————————————— */
		// Les méthodes de réactions aux appuis claviers pour le calibrage
		/*—*/
		
		// —————— CHECK KEY
		// Vérifie si une touche est enfoncé et provoque une fonction en conséquence si c'est le cas
	
		public function CheckKey( event:Event ):void {
			/*—*/
			
			// Récupère la cible
			var Cible:* = event.target;
			
			// Si le clavier n'est pas verrouillé —— - -
			if( !LockActive ){
				
				// Si la touche associée est enfoncée —— - -
				if( KeyName( Cible.Touche ) ){
	
					// Si le levier actuel est supérieur à zéro ou que le levier est à zéro constemment —— - -
					if( Cible.AppuieActuel > 0 || Cible.Appuie == 0){
						
						// Si l'événement est de type "Appuie" —— - -
						if( Cible.Etat == "Appuie" ){
							
							// Si l'événement est actif —— - -
							if( Cible.Active ){
							
								// Lancement de la fonction associée
								Launch( Cible.Fonction );
							}
						}
						
						// Réduction du levier actuel
						Cible.AppuieActuel--;
					}
				}
				
				// Si la touche associée n'est pas enfoncée et que le levier actuel n'est pas égal au levier —— - -
				if( !KeyName( Cible.Touche ) && Cible.AppuieActuel != Cible.Appuie){
					
					// Remise du levier actuel aligné avec le levier
					Cible.AppuieActuel = Cible.Appuie;
					
					// Si l'événement est de type "Relache" —— - -
					if( Cible.Etat == "Relache" ){
							
						// Si l'événement est actif —— - -
						if( Cible.Active ){
					
							// Lancement de la fonction associée
							Launch( Cible.Fonction );
						}
					}
				}
			}
		}
	  

		// —————— KEY DOWN
		// Événement d'appuie sur une touche

		public function KeyDown( event:* ):void {
			/*—*/
			
			// Si la touche n'est pas verrouillée —— - -
			if( !Lock[ GetKey( event.keyCode ) ] ){
				
				// Active la touche
				KeyStock[ event.keyCode ] = true;
				
				// Ajoute à l'Historic la touche concernée —— - -
				for( var i:* in KeyConvertList ){
					//
					if( KeyConvertList[ i ] == event.keyCode ){ 
						//
						Historic.push( i.toLowerCase() ); 
					}
				}
			}
		}
		
		
		// —————— KEY UP
		// Événement de relachement d'une touche
	
		public function KeyUp( event:* ):void {	
			/*—*/
			
			// La clé concerné passe à relachée
			KeyStock[ event.keyCode ] = false;
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 KEY					  		  					  */
		/*							 Méthodes pour calibrer des événements sur les tocuhes 				  		  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables utilisées pour les méthodes de cet ensemble
		/*—*/
		
		// —————— KEYS
		// Événements liés aux touches
		private var Keys:Object = new Object();
		
		
		
		/* —————————————————————————————————————————— - - SAVE - - —————————————————————————————————————————— */
		// Les méthodes permettant de poser des événements de touches
		/*—*/
		
		// —————— NEW KEY EVENT
		// Créer un événement sur une touche
	
		public function NewKeyEvent( Nom:String ,			// ———— - - Nom donné à l'événement
									 Touche:* ,				// ———— - - Touche appuyée
									 Fonction:* ,			// ———— - - Fonction lancé par l'événement
									 Appuie:* = 0 ,			// ———— - - Levier de l'appuie touche
									 Element:* = null ,		// ———— - - Element relié ( S'il doit être lié à l'action clavier )
									 Etat:String = "Appuie"	// ———— - - L'état de la touche pour le lancement de l'événement ( "Appuie" ou "Relache" )
									):void {
			/*—*/
			
			// Swtich des arguments
			if( !TypeOf( Touche , "String" ) ){
				//
				Etat = Element;
				Element = Appuie;
				Appuie = Fonction;
				Fonction = Touche;
				Touche = Nom;
				Nom = RandomWord();
			}
			
			// Si la touche existe —— - -
			if( KeyConvertList[ Touche ] ){
				
				// Création de l'objet servant d'écouteur à la touche
				Keys[ Nom ] = new MovieClip();
				
				// L'objet reçoit les paramètres concernant l'événement
				Keys[ Nom ].Nom = Nom;
				Keys[ Nom ].Fonction = Fonction;
				Keys[ Nom ].Touche = Touche;
				Keys[ Nom ].Appuie = ( !isNaN( Appuie ) ) ? Appuie : 0;
				Keys[ Nom ].AppuieActuel = Keys[ Nom ].Appuie;
				Keys[ Nom ].Etat = ( Element != null || !isNaN( Appuie ) ) ? Etat : ( ( Appuie == 0 ) ? "Appuie" : Appuie );
				Keys[ Nom ].Active = true;
				
				// Si on a fait passé l'élément —— - -
				if( Element ){
					
					// On donne le lien vers le Keyboard à l'élément
					Element.Link2KeyboardPort = Element.Link2KeyboardPort || new Array();
					//
					Element.Link2KeyboardPort.push( Nom );
				}
				
				// L'objet reçoit sa boucle de regard sur la touche
				AddEvents( Keys[ Nom ] , CheckKey , "ENTER_FRAME" , "KeyEvent" + Nom );
			
			// Si la touche n'existe pas —— - - Trace l'erreur
			} else {
				//
				TraceError( "KeyboardPort" , "NewKeyEvent" , [ "Le touche \"" + Touche + "\" n'existe pas." , 
															   "Vous pouvez utiliser la méthode TellMeKeys() pour obtenir la liste" + 
															   " complète des touches." ] );
			}
		}
		
		
		
		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Les méthodes permettant de manipuler les événements des touches
		/*—*/
		
		// —————— CHANGE KEY EVENT
		// Modifie un événement de touche
	
		public function ChangeKeyEvent( Nom:String , 		// ———— - - Nom de l'événement à modifier
									    Modification:*		// ———— - - Objet des modifications à apporter
									   ):void {
			/*—*/
			
			// Si l'événement éxiste —— - -
			if( Keys[ Nom ] ){
				
				// Switch des arguments —— - -
				if( TypeOf( Modification , "Function" ) ){
					//
					Modification = { fonction:Modification };
					//
				} else if( TypeOf( Modification , "Boolean" ) ){
					//
					Modification = { active:Modification };
					//
				} else if( KeyConvertList[ Modification ] ){
					//
					Modification = { key:Modification };
					//
				} else {
					//
					Modification = { number:Modification };
				}
				
				// Modifie les valeurs
				Keys[ Nom ].Fonction = Modification.fonction || Keys[ Nom ].Fonction;
				Keys[ Nom ].Touche = Modification.key || Keys[ Nom ].Touche;
				Keys[ Nom ].Appuie = ( Modification.number != null ) ? Modification.number : Keys[ Nom ].Appuie;
				Keys[ Nom ].Active = ( Modification.active != null ) ? Modification.active : Keys[ Nom ].Active;
			}
		}
		
		
		// —————— GET KEY EVENT
		// Récupère les valeurs d'un événement de touche
	
		public function GetKeyEvent( Nom:String  		// ———— - - Nom de l'événement à récupérer
								   ):Object {
			/*—*/
			
			// Objet de sortie
			var Sortie:Object = new Object();
			
			// Si l'événement éxiste —— - -
			if( Keys[ Nom ] ){
				
				// Récupère les valeurs
				Sortie.fonction = Keys[ Nom ].Fonction;
				Sortie.key = Keys[ Nom ].Touche;
				Sortie.number = Keys[ Nom ].Appuie;
				Sortie.stateNumber = Keys[ Nom ].AppuieActuel;
				Sortie.state = Keys[ Nom ].Etat;
				Sortie.active = Keys[ Nom ].Active;
			}
			
			// Retourne l'objet
			return Sortie;
		}
		
		
		// —————— REMOVE KEY EVENT
		// Supprime un événement de touche
	
		public function RemoveKeyEvent( Nom:String	// ———— - - Nom de l'événement à supprimer
									   ):void {
			/*—*/
			
			// Si l'événement éxiste —— - -
			if( Keys[ Nom ] ){
				
				// Supression de la boucle de l'objet écouteur
				RemoveEvents( Keys[ Nom ] , CheckKey , "ENTER_FRAME" , "KeyEvent" + Nom );
				
				// Néantisation de l'objet écouteur
				Keys[ Nom ] = null;
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				   SHORT KEY					  		  				  */
		/*							 Méthodes pour calibrer des événements Multi-touches 					  	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables utilisées pour les méthodes de cet ensemble
		/*—*/
		
		// —————— SHORT KEYS
		//— Relié à l'appel de touches racourcies cumulant plusieurs touches
		private var ShortKeys:Object = new Object();
		
		
		
		/* —————————————————————————————————————————— - - SAVE - - —————————————————————————————————————————— */
		// Les méthodes permettant de poser des événements de multi-touches
		/*—*/
		
		// —————— NEW SHORT KEY EVENT	 	
		// Créer un événement multi-touches
	
		public function NewShortKeyEvent( Nom:String ,			// ———— - - Nom donné à l'événement
										  Fonction:* ,			// ———— - - Fonction lancé par l'événement
										  Touche1:String ,		// ———— - - Touche N°1 associée à l'événement
										  Touche2:String ,		// ———— - - Touche N°2 associée à l'événement
										  Levier:int = 0		// ———— - - Levier de la touche
										 ):void {
			/*—*/
			
			// Si la première touche existe —— - -
			if( KeyConvertList[ Touche1 ] ){
				
				// Si la seconde touche existe —— - -
				if( KeyConvertList[ Touche2 ] ){
				
					// Création de l'objet servant d'écouteur à la touche
					ShortKeys[ Nom ] = new MovieClip();
					
					// L'objet reçoit les paramètres concernant l'événement
					ShortKeys[ Nom ].Fonction = Fonction;
					ShortKeys[ Nom ].Touche = Touche1;
					ShortKeys[ Nom ].ToucheSupplementaire = Touche2;
					ShortKeys[ Nom ].LevierActuel = Levier;
					ShortKeys[ Nom ].Levier = Levier;
					
					// L'obje reçoit sa fonction —— - -
					ShortKeys[ Nom ].Control = function( event:Event ):void {
						
						// Si les touche associées sont enfoncées —— - -
						if( KeyName( event.target.Touche ) && KeyName( event.target.ToucheSupplementaire ) ){
							
							// Si le levier actuel est supérieur à zéro ou que le levier est à zéro constemment —— - -
							if( event.target.LevierActuel > 0 || event.target.Levier == 0 ){
								
								// Lancement de la fonction associée
								Launch( event.target.Fonction );
								
								// Réduction du levier actuel
								event.target.LevierActuel--;
							}
						}
						
						
						// Si les touches associées ne sont pas enfoncées et que le levier actuel n'est pas égal au levier —— - -
						if( !KeyName( event.target.Touche ) || !KeyName( event.target.ToucheSupplementaire ) ){
							//
							if( event.target.LevierActuel != event.target.Levier ){
								
								// Remise du levier actuel aligné avec le levier
								event.target.LevierActuel = event.target.Levier;
							}
						}
					}
					
					// L'objet reçoit sa boucle de regard sur la touche
					AddEvents( ShortKeys[ Nom ] , ShortKeys[ Nom ].Control , "ENTER_FRAME" , "ShortKeyEvent" + Nom );
			
				// Si la touche n'existe pas —— - - Trace l'erreur
				} else {
					//
					TraceError( "KeyboardPort" , "NewKeyEvent" , [ "Le touche \"" + Touche2 + "\" n'existe pas." , 
																   "Vous pouvez utiliser la méthode TellMeKeys() pour obtenir la liste" + 
																   " complète des touches." ] );
				}
			
			// Si la touche n'existe pas —— - - Trace l'erreur
			} else {
				//
				TraceError( "KeyboardPort" , "NewKeyEvent" , [ "Le touche \"" + Touche1 + "\" n'existe pas." , 
															   "Vous pouvez utiliser la méthode TellMeKeys() pour obtenir la liste" + 
															   " complète des touches." ] );
			}
		}
		
		
		
		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Les méthodes permettant de manipuler les événements des multi-touches
		/*—*/
		
		// —————— REMOVE SHORT KEY EVENT
		// Supprime un événement multi-touches

		public function RemoveShortKeyEvent( Nom:String 	// ———— - - Nom de l'événement à retirer
											):void {
			/*—*/
			
			// Si le racourcie éxiste —— - -
			if( ShortKeys[ Nom ] ){
			
				// Retire sa boucle de contrôle
				RemoveEvents( ShortKeys[ Nom ] , ShortKeys[ Nom ].Control , "ENTER_FRAME" , "ShortKeyEvent" + Nom );
				
				// Le mes à null
				ShortKeys[ Nom ] = null;
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					KEYSTROKE					  	  					  */
		/*							   			Méthodes pour gestion des touches 					  		  	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - GET - - —————————————————————————————————————————— */
		// Les méthodes pour récupèrer des valeurs issues des touches
		/*—*/
		
		// —————— KEY BY NUMBER
		// Regard d'une touche par son code Ascii
	
		public function KeyNumber( Touche:Number	// ———— - - La Valeur de la touche
								   ):Boolean {
			/*—*/
			
			// Retouche si la touche est appuyée 
			return( KeyStock[ Touche ] );
		}
		
		
		// —————— KEY
		// Regard d'une touche par son nom
	
		public function KeyName( Touche:String 	// ———— - - Le Nom de la touche
								 ):Boolean {
			/*—*/
			
			// Regarde si la touche est appuyé
			return( KeyNumber( KeyConvertList[ Touche ] ) );
		}
		
		
		// —————— GET KEY
		// Renvoie le nom d'une touche à partir de son code Ascii
	
		private function GetKey( Code:* 	// ———— - - Code Ascii de la touche
								):String {			
			/*—*/
			
			// Valeur initiale
			var LevierValeur:String = "";
			
			// Pour chaque clées —— - -
			for( var iKey:* in KeyConvertList ){
				
				// S'il s'agit de ce code —— - - L'envoi
				if( KeyConvertList[ iKey ] == Code ){ 
					//
					LevierValeur = iKey; 
				}
			}
			
			// Renvoie la valeur
			return LevierValeur;
		}
	  	
	  	
		
		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Les méthodes pour modifier les effets de touches
		/*—*/
		
		// —————— LOCK KEY
		// Verrouille ou déverrouille une touche.
	
		public function LockKey( Touche:* ,				// ———— - - La ou les Touches concernées
								 Etat:Boolean = true	// ———— - - L'État de Lock
							  ):void {
			/*—*/
			
			// Si la touche est seule —— - -
			if( TypeOf( Touche , "String" ) ){
			
				// Si la touche existe 
				if( Lock[ Touche ] != null ){
					
					// Modifie l'état de la touche
					Lock[ Touche ] = Etat;
				
				// Si la touche n'existe pas —— - - Trace l'erreur
				} else { TraceError( "KeyboardPort" , "Lock" , "La touche «" + Touche + "» n'existe pas." ); }
			
			// Si la touche est plusieurs —— - -
			} else {
				
				// Verrouille chacune d'elle
				for( var i:* in Touche ){ LockKey( Touche[ i ] , Etat ); }
			}
		}
	  
	  
		// —————— LOCK
		// Verrouille ou déverrouille toutes les touches.
	
		public function LockAll( Etat:Boolean = true	// ———— - - L'État de Lock
								):void {
			/*—*/
			
			// Pour chaque touche —— - -
			for( var iKey:* in Lock ){
				
				// Modifie l'état pour celui voulu
				Lock[ iKey ] = Etat;
			}
		}
		
		
		// —————— SHAM KEY DOWN
		// Simule un appuie sur une touche

		public function ShamKeyDown( Touche:String ,				// ———— - - Touche appuyée
									 Maintient:Boolean = false ,	// ———— - - Si on la maintient
									 Relache:Boolean = false		// ———— - - Si on la relache
									):void {
			/*—*/
			
			// Boucle d'actions différée
			var ActionsDifferees:Array = new Array();
			
			// Si la clé n'est pas verouillée —— - -
			if( !Lock[ Touche ] ){
				
				// Fait la simulation de l'appuie de la touche
				KeyDown( { keyCode:KeyConvertList[ Touche ] } );
				
				// Pour chaque événement de touches —— - -
				for( var ToucheRef2:* in Keys ){
					
					// S'il est sur la touche en question —— - -
					if( Keys[ ToucheRef2 ].Touche == Touche ){
						
						// Si ce n'est pas un relachement et qu'on ne relache pas —— - -
						if( Keys[ ToucheRef2 ].Etat != "Relache" && !Relache ){
							
							// Lance son action
							Launch( Keys[ ToucheRef2 ].Fonction );
						
						// Si c'est un relachement et que l'on ne maintient pas —— - -
						} else if( Keys[ ToucheRef2 ].Etat == "Relache" && !Maintient && !Relache ){
							
							// Différe pour après la boucle
							ActionsDifferees.push( Keys[ ToucheRef2 ].Fonction );
						
						// Si c'est un relachement et qu'on relache —— - -
						} else if( Keys[ ToucheRef2 ].Etat == "Relache" && Relache ){
							
							// Lance son action
							Launch( Keys[ ToucheRef2 ].Fonction );
						}
					}
				}
				
				// Pour chaque actions différées —— - -
				for( var iAction:int = 0 ; iAction < ActionsDifferees.length ; iAction++ ){
					
					// Lance l'action
					Launch( ActionsDifferees[ iAction ] );
				}
				
				// Si on ne la maintient pas —— - - La relache dessuite
				if( !Maintient ){ ShamKeyUp( Touche ); }
			}
		}
	  

		// —————— SHAM KEY UP
		// Simule un relachement d'une touche

		public function ShamKeyUp( Touche:String	// ———— - - Touche relachée 
								  ):void {
			/*—*/
			
			// Si la clé n'est pas verouillée —— - -
			if( !Lock[ Touche ] ){
			
				// Fait la simulation du relachement de la touche
				KeyUp( { keyCode:KeyConvertList[ Touche ] } );
			}
		}
	  

		// —————— MULTI SHAM KEY
		// Lance un ensemble de simulation d'appuie cumulées sur une même frame

		public function MultiShamKey( Scenario:Array	// ———— - - Le scénario du lancement multiple
									 ):void {
			/*—*/
			
			// Pour chaque élément du scénario —— - -
			for( var iScenar:int = 0 ; iScenar < Scenario.length ; iScenar++ ){
				
				// Pour le nombre de fois qu'il faut le faire —— - -
				Scenario[ iScenar ].Nombre = Scenario[ iScenar ].Nombre || 1;
				//
				for( var iNombre:int = 0 ; iNombre < Scenario[ iScenar ].Nombre ; iNombre++ ){
					
					// S'il ne s'agit pas d'un ajout Historic —— - -
					if( !Scenario[ iScenar ].Historic ){
						
						// S'il n'est pas un relachement —— - -
						if( Scenario[ iScenar ].Relache ){
							
							// Relache la touche
							ShamKeyUp( Scenario[ iScenar ].Touche );
						}
							
						// Lance sa simulation
						ShamKeyDown( Scenario[ iScenar ].Touche , Scenario[ iScenar ].Maintient , Scenario[ iScenar ].Relache );
					
					// S'il s'agit d'un ajout Historic —— - -
					} else {
						
						// Ajoute à l'Historic
						Historic = Historic.concat( Scenario[ iScenar ].Historic.split( "" ) );
					}
				}
			}
		}
	  

		// —————— ORDER SHAM KEY
		// Lance un ensemble de simulation d'appuie

		public function OrderShamKey( Scenario:Object	// ———— - - Le scénario d'ordre de lancement
									 ):void {
			/*—*/
			
			// Créait l'objet pour cette simulation
			var SimulationObjet:Object = new Object();
			//
			SimulationObjet.Palier = 0;
			
			// Créait un nom transitoire
			var NomTransitoire:String = RandomWord();
			
			// Donne la fonction de boucle —— - -
			SimulationObjet.Boucle = function( event:Event ):void {
				
				// Varables qui sonde si on les as toutes faires
				var Continue:Boolean = false;
				
				// Pour chaque clé de l'objet
				for( var Clee:* in Scenario ){
					
					// Récupère le temps
					var TempsClee:int = ( !isNaN( Clee ) ) ? Clee : Clee.split( "_" )[ 1 ];
					
					// Si le temps correspond —— - -
					if( SimulationObjet.Palier == int( TempsClee ) ){
						
						// Appuie —— - -
						if( Scenario[ Clee ].Action != "Relache" ){
						
							// Lance l'action
							ShamKeyDown( Scenario[ Clee ].Touche , Scenario[ Clee ].Maintient );
							
						// Relache —— - -
						} else {
						
							// Lance l'action
							ShamKeyUp( Scenario[ Clee ].Touche );
						}
						
					// Si le temps est inférieur —— - -
					} else if( SimulationObjet.Palier < TempsClee ){
						//
						// On continue
						Continue = true;
					}
				}
				
				// Evolution du palier
				SimulationObjet.Palier++;
				
				// Si on ne continue plus —— - - On retire la boucle
				if( !Continue ){ RemoveEvents( This , SimulationObjet.Boucle , "ENTER_FRAME" , "LoopOrder" + NomTransitoire ); }
			}
			//
			// Donne l'événements
			AddEvents( This , SimulationObjet.Boucle , "ENTER_FRAME" , "LoopOrder" + NomTransitoire );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				    HISTORIC					  	 					  */
		/*							     Méthodes concernant l'Historic des touches 					  		  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - VARIABLES - - —————————————————————————————————————————— */
		// Les variables utilisées pour les méthodes de cet ensemble
		/*—*/
		
		// —————— HICTORIC TEXT CONVERT LIST
		// Tableaux de valeurs de conversion de l'historique
		var HistoricTextConvertList:Object = { maj_1:"&" ,
											  maj_2:"é" ,
											  maj_3:"\"" ,
											  maj_4:"'" ,
											  maj_5:"(" ,
											  maj_6:"-" ,
											  maj_7:"è" ,
											  maj_8:"_" ,
											  maj_9:"ç" ,
											  maj_0:"à" ,
											  parenthese:")" ,
											  egale:"=" ,
											  chapeau:"^" ,
											  dollar:"$" ,
											  pourcentage:"ù" ,
											  etoile:"*" ,
											  virgule:"," ,
											  pointvirgule:";" ,
											  deuxpoints:":" ,
											  pointexclamation:"!" ,
											  numpad_1:"1" ,
											  numpad_2:"2" ,
											  numpad_3:"3" ,
											  numpad_4:"4" ,
											  numpad_5:"5" ,
											  numpad_6:"6" ,
											  numpad_7:"7" ,
											  numpad_8:"8" ,
											  numpad_9:"9" ,
											  numpad_0:"0" ,
											  numpad_add:"+" ,
											  numpad_divide:"/" ,
											  numpad_multiply:"*" ,
											  numpad_substract:"-" ,
											  numpad_dot:"."
											};
		
		// —————— HICTORIC NUMBER CONVERT LIST
		// Initialise les tableaux de valeurs
		var HistoricNumberConvertList:Object = {  maj_1:"1" ,
												  maj_2:"2" ,
												  maj_3:"3" ,
												  maj_4:"4" ,
												  maj_5:"5" ,
												  maj_6:"6" ,
												  maj_7:"7" ,
												  maj_8:"8" ,
												  maj_9:"9" ,
												  maj_0:"0" ,
												  numpad_1:"1" ,
												  numpad_2:"2" ,
												  numpad_3:"3" ,
												  numpad_4:"4" ,
												  numpad_5:"5" ,
												  numpad_6:"6" ,
												  numpad_7:"7" ,
												  numpad_8:"8" ,
												  numpad_9:"9" ,
												  numpad_0:"0"
												};
		
		
		
		/* —————————————————————————————————————————— - - GET - - —————————————————————————————————————————— */
		// Les méthodes permettant de récupérer des valeurs issues de l'Historic
		/*—*/
		
		// —————— HISTORIC TO TEXT
		// Retourne, à partir de l'Historic, un ensemble de chiffre et de lettre.
		
		public function HistoricToText( ConversionForcee:Object = null ,	// ———— - - La conversion forcée de touches en valeurs
									    CaractereUnique:Boolean = true		// ———— - - Si on n'accepte que les touches uniques
									  ):String {
			/*—*/
			
			// Arguments par défaut
			ConversionForcee = ConversionForcee || new Object();
			
			// Récupère les valeurs de conversion forcée
			for( var i:* in ConversionForcee ){ HistoricTextConvertList[ i ] = ConversionForcee[ i ]; }
			
			// Initialise la variable de sortie
			var Sortie:String = "";
			
			// Pour chaque touche dans l'Historic —— - -
			for( var j:* in Historic ){
				
				// Si on ne retrouve pas la touche dans le tableau de conversion —— - -
				if( !HistoricTextConvertList[ Historic[ j ] ] ){ 
					
					// Si on n'a pas demandé les caractères uniques ou s'il s'agit d'un unique caractère —— - -
					if( !CaractereUnique || Historic[ j ].length == 1 ){
						
						// Ajoute le caractère à la sortie
						Sortie += Historic[ j ] 
					}
					
				// Si on retrouve la touche dans le tableau des conversion —— - - Ajoute la valeur convertie
				} else { Sortie += HistoricTextConvertList[ Historic[ j ] ];	}
			}
			
			// Renvoie la sortie
			return Sortie
		}
	  
	  
		// —————— HISTORIC TO NUMBER
		// Retourne, à partir de l'Historic, un ensemble chiffré.
	
		public function HistoricToNumber():int {
			/*—*/
			
			// Initialise la sortie
			var Sortie:String = "";
			
			// Pour chaque touche dans l'Historic —— - -
			for( var j:* in Historic ){
				
				// Si on la retrouve dans le tableau des conversions —— - - Ajoute le chiffre à la sortie
				if( HistoricNumberConvertList[ Historic[ j ] ] ){ Sortie += HistoricNumberConvertList[ Historic[ j ] ]; }
			}
			
			// Renvoie la sortie transtypé en chiffre entier
			return int( Sortie );
		}
		
		
		
		/* —————————————————————————————————————————— - - MANAGE - - —————————————————————————————————————————— */
		// Les méthodes permettant de modifier l'Historic
		/*—*/
		
		// —————— REFRESH HISTORIC
		// Vide l'Historique
	
		public function RefreshHistoric():void {
			/*—*/
			
			// Mes à zéro l'Historic
			Historic = [];
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				      HELP						  	 					  */
		/*							     		 Méthodes d'aide pour ce script 					  		  	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - TRACE - - —————————————————————————————————————————— */
		// Les méthodes pour tracer des valeurs
		/*—*/
		
		// —————— TELL ME KEYS
		// Retourne toutes les clées avec leur nom et leur valeur Ascii
		
		function TellMeKeys():void {
			/*—*/
			
			// Démarre
			Tr();
			Trace( "Les clés du clavier sont :" );
			
			// Pour chaque clés —— - -
			for( var iKey:* in KeyConvertList ){
				
				// Trace la clé
				Trace( iKey + " = " + KeyConvertList[ iKey ] );
			}
			
			// Termine
			Tr();
		}
		
		
		
		
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}