<?php
	
	// Créer l'objet de document XML
	$dom = new DomDocument();
	
	// Chargement du XMl
	$dom->load('monXml.xml');
	
	// Chargement du XML par le biais d'un objet
	//$dom->loadXML($chaineXML);
	
	// Sauvegarder le XML
	//$dom->save('nouveauFichier.xml');
	
	// Sauvegarder le XML sous un objet
	//$chaineXML = $dom->saveXML();
	
	// Récupère la racine du XML
	$racine = $dom->documentElement;
	
	// Récupère la liste des noeud d'un noeud
    $leYak = $dom->getElementsByTagName('yak1')->item(0);
    $listeElement = $leYak->getElementsByTagName('Element');
    
    // Pour chaque noeud du noeud -->
    foreach( $listeElement as $monElement ){
		
		// Écrit son contenu
		echo "C'est ainsi : " . $monElement->nodeValue;
		
		// S'il a le paramètres "test" -->
		if ( $monElement->hasAttribute("test") ) {
			//
			// Écrit le paramètres "test"
			echo  " Avec " . $monElement->getAttribute("test");
		}
		//
		echo "<br />";
	}
	
	// Créait un nouveau noeud pas encore intégré
	$nouveauNoeud = $dom->createElement( "lapin" );
	
	// Créait un nouvel élément textuel pas encore intégré
	$nomElement = $dom->createTextNode( "Chat" );
	
	// Créait un noeud cloné
	// $paysIdentique = $pays->cloneNode();
	
	// Créait un attribue à un noeud
	$nouveauNoeud->setAttribute("Glouarg", "Graaaaaaa");
	
	// Intégre le noeud au Xml
	//
	// Lui donne son texte
	$nouveauNoeud->appendChild($nomElement);
	//
	// Le donne à l'Xml
    $ZoneDePlacement = $dom->getElementsByTagName("yak1")->item(0);
    $ZoneDePlacement->appendChild($nouveauNoeud);
	
	// Supprimer un noeud
	// $europe->removeChild($nouveauPays);
	
	// Sauvegarder le XML
	$dom->save('monSecondXml.xml');
?>