﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			 ASSIST FACTORY	  		Version 0.4.4									***/
/***				   				   Dernière Mise à Jour : 10-09-29										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         			    Assemblages Généraux											***/
/***	Ce script facilite certaines méthodes sur d'autres scripts ou scènes par le biais de communication  ***/
/***	Xml.																								***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Global {
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	
	// —— - - DISPLAY
	// 
	import flash.display.MovieClip;
	
	// —— - - EVENT
	// 
	import flash.events.Event;
	
	// —— - - drOIde
	// 
	import drOIde.Global.MiscTools;
	import drOIde.Link.PaperTools;
	import drOIde.Link.FileProcess;
	import drOIde.Media.VideoProcess;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	
	public class AssistFactory extends MiscTools{
		
		
		
		
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*												   				  										  */
	/*				 	      					  VARIABLES GLOBALES										  */
	/*		  							 Les variables d'utilisations globales								  */
	/*												   				  										  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		//*——*//
		
		// —————— LINK
	    // Les liaisons aux autres scripts
		private var Paper:PaperTools = new PaperTools();
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/// Non-Utilisé
		public function AssistFactory( TheLink:* = null		// ———— - - Lien vers la scène
									  ):void {
			/*—*/
			
			// Établit la connexion
			Connexion( TheLink );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 MULTIPLE					  		  				  */
		/*								Sauvegarde et archivage d'ensemble de données variées 					  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - SAVE - - —————————————————————————————————————————— */
		// Méthodes pour lancer des sauvegardes
		//*—*//
		
		// —————— MULTI ARCHIVE
		// Archive un ensemble de données par le biais d'Xml multiples
		
		public function MultiArchive( Ensemble:* ,								// ———— - - L'Ensemble des chargements à procéder
									  FonctionFin:Object = null ,				// ———— - - La Fonction de fin
									  FonctionTransitionnelle:Object = null ,	// ———— - - La Fonction de transition entre deux chargements
									  FonctionErreur:Object = null				// ———— - - La Fonction en cas d'erreur
								    ):void {
			/*—*/
			
			// Calibre l'ensemble
			Ensemble = ( TypeOf( Ensemble , "Array" ) ) ? Ensemble : [ Ensemble ];
			
			// Créait l'objet d'archivage multiple
			var MultiArchivageObject:Object = new Object();
			//
			// Intégre le numéro
			MultiArchivageObject.Numero = -1;
			//
			// Intégre la fonction —— - -
			MultiArchivageObject.Next = function():void {
				
				// S'il ne s'agit pas du premier lancement —— - - 
				if( MultiArchivageObject.Numero != -1 ){
					
					// Lance sa fonction relié ou la fonction transitionnelle
					Launch( Ensemble[ MultiArchivageObject.Numero ].Fonction || FonctionTransitionnelle );
				}
				
				// Augmente le numéro
				MultiArchivageObject.Numero++;
				
				// S'il ne s'agit pas du dernier —— - -
				if( MultiArchivageObject.Numero < Ensemble.length ){
					
					// Lance l'Archivage du suivant
					This[ "Archive" + Ensemble[ MultiArchivageObject.Numero ].Archivage ]( 
					   	  Ensemble[ MultiArchivageObject.Numero ].Script , 
					   	  Ensemble[ MultiArchivageObject.Numero ].Lien , 
					   	  { 
						  	Fonction:MultiArchivageObject.Next ,
							Erreur:( FonctionErreur != null ) ? { Cible:MultiArchivageObject , Fonction:"Erreur" , 
																  Xml:Ensemble[ MultiArchivageObject.Numero ].Lien } : null
						  } ,
					   	  Ensemble[ MultiArchivageObject.Numero ].Parametres );
					
				// S'il s'agit du dernier —— - -
				} else {
					
					// Lance la fonction de fin
					Launch( FonctionFin );
				}
			}
			//
			// Intégre la fonction d'erreur —— - -
			MultiArchivageObject.Erreur = function( TexteErreur:String , // —— - - Le texte de l'erreur
												    Argument:*			 // —— - - Les arguments en court
												   ):void {
				
				// Lance la fonction d'erreur avec l'argument du chemin d'accés du Xml foireux
				Launch( FonctionErreur , true , [ Argument.Fonction.Erreur.Xml ] );
			}
			
			// Lance le premier chargement
			MultiArchivageObject.Next();
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					   DATA					  		  					  */
		/*								Procédés pour favoriser les chargements de données. 					  */
		/*		C'est éxactement le même principe que pour les chargements de la PaperTools mais le mode de 		  */
		/*		fonctionnement est prévu pour être compatible avec le MultiArchivage.  							  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - SAVE - - —————————————————————————————————————————— */
		// Méthodes pour lancer des sauvegardes
		//*—*//
		
		// —————— ARCHIVE DATA
		// Archive un ensemble de données
		
		public function ArchiveData( LienObjet:Object ,			// ———— - - Le Lien d'instance pour l'objet obtenu
									 LienXml:String ,			// ———— - - Le Fichier Xml indiquant les détails
								     Fonction:Object = null ,	// ———— - - La Fonction à lancer à la fin du chargement
									 Parametres:* = null		// ———— - - Les Parametres supplémentaires
								   ):void {
			/*—*/
			
			// Arguments par défaut
			Parametres = Parametres || new Object();
			
			// Vérifie les clés de l'objet
			if( TraceIfNotKey( LienObjet , [ "Cible" , "Nom" ] , "AssistFactory" , "ArchiveData" , "LienObjet" ) ){
				
				// Lance la lecture du fichier Xml
				Paper.XMLLoad( LienXml ,
							   {
								   fonctionEnd:{ Fonction:ArchiveData_Step2 , 
								   				 Argument:{ LienObjet:LienObjet , 
												 			Fonction:Fonction , 
															LienXml:LienXml } ,
								   fonctionError:Parametres.fonctionError
							   } } );
			}
		}
		//
		// —————— ARCHIVE DATA - STEP 2
		// Etape n°2 après récupération des données          									 	
		public function ArchiveData_Step2( Objet:Object ,	// ———— - - L'Objet Xml
										   Elements:Object	// ———— - - Le Clip conteneur
										  ):void {
			/*—*/
			
			// Récupère l'instance de l'objet
			var LienObjet:Object = Elements.LienObjet;
			
			// Donne le lien de l'objet chargé au lien d'instance
			LienObjet.Cible[ LienObjet.Nom ] = Objet;
			
			// Lance la fonction finale
			Launch( Elements.Fonction );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					   CLASS					  		  				  */
		/*		Lance le chargement d'un ensemble de scène flash pour ajouter des classes à la scène en cours. 	  */
		/*		Pour l'instant, cette méthode n'est pas compatible avec le MultiArchivage.						  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - SAVE - - —————————————————————————————————————————— */
		// Méthodes pour lancer des sauvegardes
		//*—*//
		
		// —————— ARCHIVE CLASS
		// Archive un ensemble de Class par le biais de scène Swf chargées en externe
		
		public function ArchiveClass( LienXml:String ,		// ———— - - Le Fichier Xml indiquant les détails
								      Fonction:* = null ,	// ———— - - La Fonction à lancer à la fin du chargement
									  Parametres:* = null	// ———— - - Les Parametres supplémentaires
								   ):void {
			/*—*/
			
			// Arguments par défaut
			Parametres = Parametres || new Object();
				
			// Lance la lecture du fichier Xml
			Paper.XMLLoad( LienXml ,
						   {
							   fonctionEnd:{ Fonction:ArchiveClass_Step2 , 
											 Argument:{ Fonction:Fonction , 
											 			LienXml:LienXml } ,
							   fonctionError:Parametres.fonctionError
						   } } );
		}
		//
		// —————— ARCHIVE CLASS - STEP 2
		// Etape n°2 après récupération des données             									 	
		public function ArchiveClass_Step2( Objet:Object ,		// ———— - - L'Objet Xml
										   	Elements:* = null	// ———— - - Le Clip conteneur
										  ):void {
			/*—*/
			
			// Créait l'objet Link
			var File:FileProcess = new FileProcess();
			
			// Créait l'objet de fonction
			var ClassObject:Object = new Object();
			//
			// Lui donne son tableau
			ClassObject.Tableau = new Array();
			
			// Pour chaque Lien —— - -
			for( var iFile:* in Objet ){
				
				// Ajoute son lien au tableau
				ClassObject.Tableau.push( Objet[ iFile ].Parametres.Lien );
			}
			
			// Lui donne sa fonction de retour
			ClassObject.Fonction = function():void {
				
				// Retire le dernier élément de la liste des liens
				var leLien:String = ClassObject.Tableau.pop();
				
				// Lance la fonction de chargement puis la fait relancer cette fonction ou la fonction finale suivant s'il reste des liens
				File.SWFLibraryLoad( leLien , { fonctionEnd:( ClassObject.Tableau.length > 0 ) ? ClassObject.Fonction : Elements.Fonction } );
			}
			
			// Lance la fonction de retour
			ClassObject.Fonction();
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					   SOUND					  		  				  */
		/*								Procédés pour favoriser les méthodes de l'SoundProcess. 	 			  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - SAVE - - —————————————————————————————————————————— */
		// Méthodes pour lancer des sauvegardes
		//*—*//
		
		// —————— ARCHIVE SOUND
		// Archive un ensemble de son
		
		public function ArchiveSound( Sound:* ,					// ———— - - Le Lien du SoundProcess
								      LienXml:String ,			// ———— - - Le Fichier Xml indiquant les détails
								      Fonction:Object = null ,	// ———— - - La Fonction à lancer à la fin du chargement
									  Parametres:* = null		// ———— - - Les Parametres supplémentaires
								   ):void {
			/*—*/
			
			// Arguments par défaut
			Parametres = Parametres || new Object();
				
			// Lance la lecture du fichier Xml
			Paper.XMLLoad( LienXml ,
						   {
							   fonctionEnd:{ Fonction:ArchiveSound_Step2 , 
											 Argument:{ Sound:Sound , 
											 			Fonction:Fonction , 
														LienXml:LienXml } ,
							   fonctionError:Parametres.fonctionError
						   } } );
		}
		//
		// —————— ARCHIVE SOUND - STEP 2
		// Etape n°2 après récupération des données 								 	
		public function ArchiveSound_Step2( Objet:Object ,		// ———— - - L'Objet Xml
										   	Elements:Object		// ———— - - Le Clip conteneur
										  ):void {
			/*—*/
			
			// Récupère l'instance de l'SoundProcess
			var Sound:* = Elements.Sound;
			
			// Pour chaque groupe —— - -
			for( var Groupe:* in Objet ){
				
				// S'il ne s'agit pas d'un groupe aléatoire —— - -
				if( !FindIn( Groupe , "Noise_" ) ){
					
					// Créait le groupe et lui donne ses paramètres
					Sound.NewSoundGroup( Groupe , ( Objet[ Groupe ].Parametres || new Object() ) );
					
					// Pour chaque son du groupe —— - -
					for( var Sons:* in Objet[ Groupe ] ){
						
						// Définit les parametres à transmettre
						var ParametresTransmis:Object = Objet[ Groupe ][ Sons ].Parametres;
						//
						// Pour chaque parametres du sons —— - -
						for( var Param:* in ParametresTransmis ){
							
							// Convertie le parametres —— - -
							ParametresTransmis[ Param ] = StringOrNumber( ParametresTransmis[ Param ] );
						}
						
						// Si ce n'est pas un paramètres —— - -
						if( Sons != "Parametres" ){
	
							// Créait le son avec ses paramètres
							Sound.NewSound( Groupe , Sons , String( Objet[ Groupe ][ Sons ].Parametres.Lien ) , ParametresTransmis );
						}
					}
					
					
				// S'il s'agit d'un son aléatoire —— - - 
				} else {
					
					// Créait le groupe aléatoire
					Sound.NewNoiseGroup( Pop( Groupe , "Noise_" ) );
					
					// Pour chaque son aléatoire du groupe —— - -
					for( var R_Sons:* in Objet[ Groupe ] ){
					
						// Créait le tableau des sons intégrés
						var NouveauSonAleatoire:Array = new Array();
						
						// Pour chaque sons du son aléatoire
						for( var R_Son:* in Objet[ Groupe ][ R_Sons ].Parametres ){
							
							// L'ajoute au tableau
							NouveauSonAleatoire.push( [ Objet[ Groupe ][ R_Sons ].Parametres[ R_Son ].split( "/" )[ 0 ] , 
														Objet[ Groupe ][ R_Sons ].Parametres[ R_Son ].split( "/" )[ 1 ] ] );
						}
						
						// Ajoute le son aléatoire
						Sound.NewNoise( Pop( Groupe , "Noise_" ) , R_Sons , NouveauSonAleatoire );
					}
				}
			}
			
			// Lance la fonction finale
			Launch( Elements.Fonction );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					   BRAIN					  		  				  */
		/*								Procédés pour favoriser les méthodes de la PlayerProcess. 				  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - SAVE - - —————————————————————————————————————————— */
		// Méthodes pour lancer des sauvegardes
		//*—*//
		
		// —————— ARCHIVE BRAIN
		// Archive un ensemble d'intelligence
		
		public function ArchiveBrain( Player:* ,				// ———— - - Le Lien de PlayerProcess
								      LienXml:String ,			// ———— - - Le Fichier Xml indiquant les détails
								      Fonction:Object = null ,	// ———— - - La Fonction à lancer à la fin du chargement
									  Parametres:* = null		// ———— - - Les Parametres supplémentaires
								   ):void {
			/*—*/
			
			// Arguments par défaut
			Parametres = Parametres || new Object();
				
			// Lance la lecture du fichier Xml
			Paper.XMLLoad( LienXml ,
						   {
							   fonctionEnd:{ Fonction:ArchiveBrain_Step2 , 
											 Argument:{ Player:Player , 
											 			Fonction:Fonction , 
														Parametres:Parametres } ,
							   fonctionError:Parametres.fonctionError
						   } } );
		}
		//
		// —————— ARCHIVE BRAIN - STEP 2
		// Etape n°2 après récupération des données 					 	
		public function ArchiveBrain_Step2( Objet:Object ,		// ———— - - L'Objet Xml
										   	Elements:Object		// ———— - - Les valeurs additives
										  ):void {
			/*—*/
			
			//// Récupère l'instance de l'SoundProcess
			var Player:* = Elements.Player;
			var Parametres:Object = Elements.Parametres;
			
			// Tableau des intelligences à donner
			var Intelligences:Array = new Array();
			
			// Pour chaque groupe —— - -
			for( var Intelligence:* in Objet ){
				
				// S'il ne s'agit pas de la clé Contenu ou Parametres —— - -
				if( Intelligence != "Parametres" && Intelligence != "Contenu" ){
					
					// Ajoute le nouvel objet d'intelligence
					Intelligences.push( { Groupe:( Objet.Parametres ) ? Objet.Parametres.Groupe : "IA" , Nom:Intelligence , Intelligence:{} } );
					//
					// Récupére son instance
					var IntelligenceEnCour:Object = Intelligences[ Intelligences.length - 1 ].Intelligence;
					
					// Pour chaque méthodes de l'intelligence —— - -
					for( var Methodes:* in Objet[ Intelligence ] ){
						
						// S'il ne s'agit pas de la clé Contenu ou Parametres —— - -
						if( Methodes != "Parametres" && Methodes != "Contenu" ){
							
							// Créait l'objet pour cette méthode
							IntelligenceEnCour[ Methodes ] = new Object();
							
							// Pour parametres de la méthode —— - -
							for( var Developpement:* in Objet[ Intelligence ][ Methodes ].Parametres ){
								
								// Ajoute ce parametres
								IntelligenceEnCour[ Methodes ][ Developpement ] = StringOrNumber( Objet[ Intelligence ][ Methodes ].Parametres[ Developpement ] );
								
								// Essaye —— - -
								try{
									
									// S'il contient un séparateur de deux points —— - -
									if( IntelligenceEnCour[ Methodes ][ Developpement ].split( ":" ).length > 1 ){
										
										// Récupére l'instance du clip concernée
										IntelligenceEnCour[ Methodes ][ Developpement ] = 
															Parametres.Racine[ IntelligenceEnCour[ Methodes ][ Developpement ].split( ":" )[ 1 ] ];
									}
								//
								} catch( e ){}
							}
							
							// Pour chaque méthodes interne à la méthode —— - -
							for( var Interne:* in Objet[ Intelligence ][ Methodes ] ){
								
								// S'il ne s'agit pas de la clé Contenu ou Parametres —— - -
								if( Interne != "Parametres" && Interne != "Contenu" ){
									
									// Créait l'objet de la méthode interne
									IntelligenceEnCour[ Methodes ][ Interne ] = new Object();
									
									// Pour chaque méthodes interne à la méthode —— - -
									for( var InterneDeep:* in Objet[ Intelligence ][ Methodes ][ Interne ] ){
										
										// S'il ne s'agit pas de la clé Contenu ou Parametres —— - -
										if( InterneDeep != "Parametres" && InterneDeep != "Contenu" ){
											
											// Créait l'objet
											IntelligenceEnCour[ Methodes ][ Interne ][ InterneDeep ] = new Object();
											
											// Pour chaque parametres de la méthode interne —— - -
											for( var InterneDeepDonnees:* in Objet[ Intelligence ][ Methodes ][ Interne ][ InterneDeep ].Parametres ){
												
												// Ajoute le parametre de la méthode interne
												IntelligenceEnCour[ Methodes ][ Interne ][ InterneDeep ][ InterneDeepDonnees ] = 
												Objet[ Intelligence ][ Methodes ][ Interne ][ InterneDeep ].Parametres[ InterneDeepDonnees ];
											}
										}
									}
									
									// Pour chaque parametres de la méthode interne —— - -
									for( var InterneDonnees:* in Objet[ Intelligence ][ Methodes ][ Interne ].Parametres ){
										
										// Ajoute le parametre de la méthode interne
										IntelligenceEnCour[ Methodes ][ Interne ][ InterneDonnees ] = 
															StringOrNumber( Objet[ Intelligence ][ Methodes ][ Interne ].Parametres[ InterneDonnees ] );
										
										// Essaye —— - -
										try { 
											
											// S'il contient un séparateur de deux points —— - -
											if( IntelligenceEnCour[ Methodes ][ Interne ][ InterneDonnees ].split( ":" ).length > 1 ){
										
												// Récupére l'instance du clip concerné
												IntelligenceEnCour[ Methodes ][ Interne ][ InterneDonnees ] = 
														Parametres.Racine[ IntelligenceEnCour[ Methodes ][ Interne ][ InterneDonnees ].split( ":" )[ 1 ] ];
											}
										//
										} catch( e ){}
									}
								}
							}
						}
					}
				}
			}
			
			// Pour chaque intelligence ainsi récupérée —— - -
			for( var i:int = 0 ; i < Intelligences.length ; i++ ){
				
				// Ajoute cette intelligence à l'archivage du PlayerProcess
				Player.NouvelleIntelligence( Intelligences[ i ].Groupe , Intelligences[ i ].Nom , Intelligences[ i ].Intelligence );
			}
			
			// Lance la fonction finale
			Launch( Elements.Fonction );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					  TEXT						  		  				  */
		/*							  Procédés pour favoriser les méthodes du TextProcess. 					  	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - SAVE - - —————————————————————————————————————————— */
		// Méthodes pour lancer des sauvegardes
		//*—*//
		
		// —————— ARCHIVE TEXT
		// Archive un ensemble de texte et données CSS
		
		public function ArchiveText( Text:* ,					// ———— - - Le Lien de TexteProcess
									 LienXml:String ,			// ———— - - Le Fichier Xml indiquant les détails
									 Fonction:* = null ,		// ———— - - La Fonction à lancer à la fin du chargement
									 Parametres:* = null		// ———— - - Les Parametres supplémentaires
								   ):void {
			/*—*/
			
			// Arguments par défaut
			Parametres = Parametres || new Object();
				
			// Lance la lecture du fichier Xml
			Paper.XMLLoad( LienXml ,
						   {
							   fonctionEnd:{ Fonction:ArchiveText_Step2 , 
											 Argument:{ Text:Text , 
											 			Fonction:Fonction , 
														Parametres:Parametres } ,
							   fonctionError:Parametres.fonctionError
						   } } );
		}
		//
		// —————— ARCHIVE TEXT - STEP 2
		// Etape n°2 après récupération des textes					
		public function ArchiveText_Step2( Objet:Object ,		// ———— - - L'Objet Xml
										   Elements:Object		// ———— - - Les Valeurs additives
										  ):void {
			/*—*/
			
			// Pour chaque noeud de l'objet —— - -
			for( var iGroupe:* in Objet ){
				
				// Si ce n'est pas un Paramètres ou contenu —— - -
				if( iGroupe != "Parametres" && iGroupe != "Contenu" ){
					
					// S'il possède des paramètres —— - -
					if( Objet[ iGroupe ].Parametres ){
						
						// Compose l'objet CSS
						var ObjectCSS:Object = new Object();
						
						// Pour chaque objet de ses parametres —— - -
						for( var iCSS:* in Objet[ iGroupe ].Parametres ){
							
							// Compose la définition du CSS
							var CompoCSS:Object = new Object();
							
							// Décompose le contenu du parametres
							var ContenuParametre:Array = Objet[ iGroupe ].Parametres[ iCSS ].split( ";" );
							
							// Pour chaque élément du parametre —— - -
							for( var iContenuParametre:int = 0 ; iContenuParametre < ContenuParametre.length ; iContenuParametre++ ){
								
								// Le coupe en deux et l'intégre
								var Partie:String = ContenuParametre[ iContenuParametre ].split( ":" )[ 0 ];
								var Valeur:String = ContenuParametre[ iContenuParametre ].split( ":" )[ 1 ];
								//
								CompoCSS[ Partie ] = Valeur;
							}
							
							// Ajoute un nouveau tableau au CSS
							ObjectCSS[ iCSS ] = CompoCSS;
						}
						
						// Créait le groupe
						Elements.Text.NewTextGroup( iGroupe , { CSS:ObjectCSS } );
						
						
						// Pour chaque élément du nœud —— - -
						for( var iElement:* in Objet[ iGroupe ] ){
				
							// Si ce n'est pas un Paramètres ou contenu —— - -
							if( iElement != "Parametres" && iElement != "Contenu" ){
								
								// S'il possède un contenu
								if( Objet[ iGroupe ][ iElement ].Contenu ){
									
									// Ajoute l'objet texte
									Elements.Text.NewText( iGroupe , iElement , 
														   CharacterConversion( Objet[ iGroupe ][ iElement ].Contenu , 
																				[ "[" , "]" , "\t" , "\r" , "\n" ] , 
																				[ "<" , ">" , "" , "" , "" ] )
														  );
								}
							}
						}
					}
				}
			}
			
			// Lance la fonction de fin
			Launch( Elements.Fonction );
		}
		
		
		// —————— ARCHIVE SUB TITLE
		// Archive un ensemble de sous-titre
		
		public function ArchiveSubTitle( Text:* ,					// ———— - - Le Lien de TexteProcess
									     LienXml:String ,			// ———— - - Le Fichier Xml indiquant les détails
								         Fonction:Object = null ,	// ———— - - La Fonction à lancer à la fin du chargement
									     Parametres:* = null		// ———— - - Les Parametres supplémentaires
									   ):void {
			/*—*/
			
			// Arguments par défaut
			Parametres = Parametres || new Object();
				
			// Lance la lecture du fichier Xml
			Paper.XMLLoad( LienXml ,
						   {
							   fonctionEnd:{ Fonction:ArchiveSubTitle_Step2 , 
											 Argument:{ Text:Text , 
											 			Fonction:Fonction , 
														Parametres:Parametres } ,
							   fonctionError:Parametres.fonctionError
						   } } );
		}
		//
		// —————— ARCHIVE SUB TITLE - STEP 2
		// Etape n°2 après récupération des données 					
		public function ArchiveSubTitle_Step2( Objet:Object ,		// ———— - - L'Objet Xml
										   	   Elements:Object		// ———— - - Les Valeurs additives
											  ):void {
			/*—*/
			
			// Pour chaque noeud de l'objet —— - -
			for( var iGroupe:* in Objet ){
				
				// Si ce n'est pas un Paramètres ou contenu —— - -
				if( iGroupe != "Parametres" && iGroupe != "Contenu" ){
				
					// Pour chaque noeud de ce noeud —— - -
					for( var iNom:* in Objet[ iGroupe ] ){
						
						// Récupèer l'objet
						var SubTitleObject:Object = Objet[ iGroupe ][ iNom ];
						
						// Si ce n'est pas un Paramètres ou contenu —— - -
						if( iNom != "Parametres" && iNom != "Contenu" ){
							
							// Créait le nouveau sous-titre
							Elements.Text.NewSubTitle( iGroupe , 
													   iNom , 
													   SubTitleObject.Contenu || SubTitleObject.Text , 
													   Elements.Parametres.container ,
													   SubTitleObject.Timing ,
													   {
														   next:SubTitleObject.Next
													   } 
													  );
						}
					}
				}
			}
		}
		
		
		
	  	
		    
		
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}