﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			  SYSTEM TOOLS	  	  Version 0.5.0										***/
/***				   				   Dernière Mise à Jour : 10-08-14										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         				    Outils Systeme												***/
/***	Ce script contient les méthodes permettant d'agir, sur ou à partir des données du processeur.	    ***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Global {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	  
	// —— - - DISPLAY
	import flash.display.MovieClip;
	import flash.display.StageScaleMode;
	import flash.display.StageAlign;
	//
	// —— - - EVENT
	import flash.events.Event;
	import flash.events.ContextMenuEvent;
	//
	// —— - - SYSTEM
	import flash.system.Capabilities;
	import flash.system.fscommand;
	import flash.system.System;
	//
	// —— - - UI
	import flash.ui.ContextMenu;
	import flash.ui.ContextMenuItem;
	import flash.ui.ContextMenuBuiltInItems;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class SystemTools extends MiscTools {
		
		
		
		
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*												   				  										  */
	/*				 	      					  VARIABLES GLOBALES										  */
	/*		  							 Les variables d'utilisations globales								  */
	/*												   				  										  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		//*——*//
		
		// —————— GESTION
		// Etat de control du script
		private var ControlActive:Boolean = false;
		
		
		// —————— TAILLE ECRANS
		// Tailles écran initiales
		private var InitialScreenWidth:Number = 1024;
		private var InitialScreenHeight:Number = 768;
		//
		// Tailles écran
		public var ScreenWidth:Number = 1024;
		public var ScreenHeight:Number = 768;
		
		
		// —————— POINTS CIBLES
		//— Points de définitions pour la gestion d'éléments à l'écran
		public var XMin:Number = 0;
		public var YMin:Number = 0;
		//
		public var XMax:Number = 0;
		public var YMax:Number = 0;
		//
		public var XCen:Number = 0;
		public var YCen:Number = 0;
		
		
		// —————— REDIMENSIONNABLE
		// Si la scène est en mode redimensionnable ( Pour la gestion d'élément à l'écran )
		public var Resizable:Boolean = false;
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  	/**/
		/**/
		public function SystemTools( TheLink:* = null , 			// ———— - - Lien vers la scène
									   LanceGestion:Boolean = false	// ———— - - S'il lance la boucle de gestion
									  ):void {
			/*—*/
			
			// Récupère l'instance de stage si ça en est bien un —— - - Sinon Trace l'erreur
			if( !Connexion( TheLink ) ){
				//
				TraceError( "SystemTools" , "Initialisation" , 
							 "Un argument vers la scène doit être mis à l'initialisation du script." );	
			}
			
			
			// Si on demande le lancement de la gestion —— - -
			if( LanceGestion ){
				
				// Récupère les tailles d'écran initiales
				InitialScreenWidth = StageLink.stageWidth;
				InitialScreenHeight = StageLink.stageHeight;
				
				// Lance la gestion de l'écran
				ScreenManage();
			}
		}
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 GLOBAL					  		  					  */
		/*									Méthodes de gestion globale de du script 					  		  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - LOOP - - —————————————————————————————————————————— */
		// Les méthodes de boucle et gestion de boucle du script
		//*—*//
		
		// —————— SCREEN MANAGE
		// Vérifie, en permanence, la taille écran et la position des quatres coins écran
		
		public function ScreenManage():void { 
			/*—*/
			
			// Si la gestion n'est pas déjà lancé —— - -
			if( !ControlActive ){
				
				// Lance la boucle
				AddEvents( this , ScreenManageLoop , "ENTER_FRAME" ); 
				
				// Active le control
				ControlActive = true;
			}
		}
		//
		// —————— SCREEN MANAGE LOOP
		// Boucle de gestion écran
		public function ScreenManageLoop( event:Event ):void {
			/*—*/
			
			// Récupère la taille écran
			ScreenWidth = StageLink.stageWidth;
			ScreenHeight = StageLink.stageHeight;
			
			// Si l'alignement n'est pas en haut-gauche —— - -
			if( StageLink.align != "TL" ){
				
				// Par rapport à la taille écran initiale et actuelle, —— - - Récupére
				//
				// Les positions X & Y minimales
				XMin = ( ScreenWidth - InitialScreenWidth ) / -2;
				YMin = ( ScreenHeight - InitialScreenHeight ) / -2;
				//
				// Les positions X & Y maximales
				XMax = InitialScreenWidth + ( ScreenWidth - InitialScreenWidth ) / 2;
				YMax = InitialScreenHeight + ( ScreenHeight - InitialScreenHeight ) / 2;
			
			// Sinon —— - -
			} else {
				
				// Définit les valeurs
				XMin = 0;
				YMin = 0;
				//
				XMax = ScreenWidth;
				YMax = ScreenHeight;
			}
			
			
			// Si la mise en forme est redimensionnable —— - -
			if( Resizable ){ 
			
				// Modifie X Min
				XMin -= ( InitialScreenWidth - InitialScreenWidth * ( ( ( ScreenHeight / InitialScreenHeight ) < ( ScreenWidth / InitialScreenWidth ) ) ? 
						  ( ScreenHeight / InitialScreenHeight ) 
						: ( ScreenWidth / InitialScreenWidth ) ) ) 
						* ( InitialScreenHeight / ( ScreenHeight - ( ( ScreenHeight - InitialScreenHeight ) / 2 ) ) );
						
				// Modifie Y Min
				YMin -= ( InitialScreenHeight - InitialScreenHeight * ( ( ( ScreenHeight / InitialScreenHeight ) < ( ScreenWidth / InitialScreenWidth ) ) ? 
						  ( ScreenHeight / InitialScreenHeight ) 
						: ( ScreenWidth / InitialScreenWidth ) ) ) 
						* ( InitialScreenWidth / ( ScreenWidth - ( ( ScreenWidth - InitialScreenWidth ) / 2 ) ) );
						
				// Modifie X Max
				XMax += ( InitialScreenWidth - InitialScreenWidth * ( ( ( ScreenHeight / InitialScreenHeight ) < ( ScreenWidth / InitialScreenWidth ) ) ? 
						  ( ScreenHeight / InitialScreenHeight ) 
						: ( ScreenWidth / InitialScreenWidth ) ) ) 
						* ( InitialScreenHeight / ( ScreenHeight - ( ( ScreenHeight - InitialScreenHeight ) / 2 ) ) );
						
				// Modifie X Max
				YMax += ( InitialScreenHeight - InitialScreenHeight * ( ( ( ScreenHeight / InitialScreenHeight ) < ( ScreenWidth / InitialScreenWidth ) ) ? 
						  ( ScreenHeight / InitialScreenHeight ) 
						: ( ScreenWidth / InitialScreenWidth ) ) ) 
						* ( InitialScreenWidth / ( ScreenWidth - ( ( ScreenWidth - InitialScreenWidth ) / 2 ) ) );
			}
			//
			// Les positions X & Y centrales
			XCen = XMin / 2 + XMax / 2;
			YCen = YMin / 2 + YMax / 2;
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 DATA					  		  					  */
		/*				Méthodes pour récupérer ou modifier les données Systémes de gestion du Flash 			  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - GET - - —————————————————————————————————————————— */
		// Méthodes pour récupérer les données systémes
		//*—*//
		
		// —————— GET LANGUAGE		           									 	
		//Retourne la langue de l'OS
		
		public function GetLanguage():String { 
			/*—*/
			
			// Retourne la valeur
			return Capabilities.language; 
		}
		  
			
		// —————— GET OS
		// Retourne le type du système d'exploitation
		
		public function GetOS():String { 
			/*—*/
			
			// Retourne la valeur
			return Capabilities.os; 
		}
		
		
		// —————— IS AUDIO
		// Indique si le support audio est accessible sur le system
		
		public function IsAudio():Boolean { 
			/*—*/
			
			// Retourne la valeur
			return Capabilities.hasAudio; 
		}
		
		
		
		/* —————————————————————————————————————————— - - SET - - —————————————————————————————————————————— */
		// Méthodes pour modifier les données systémes
		//*—*//
		
		// —————— SET ALIGN MODE           									 	
		// Définit le type d'alignement de la scène
		
		public function SetAlignMode( Etat:String = "TL" 	// ———— - - Type d'alignement choisi
									 ):void {
			/*—*/
			
			// Objet des types
			var Types:Object = { T:"TOP" ,
								 B:"BOTTOM" ,
								 L:"LEFT" ,
								 R:"RIGHT" ,
								 TL:"TOP_LEFT" ,
								 TP:"TOP_RIGHT" ,
								 BL:"BOTTOM_LEFT" ,
								 BR:"BOTTOM_RIGHT"
								};
								
			// Modifie l'alignement
			StageLink.align = StageAlign[ Types[ Etat ] ];
		}
		
		  
		// —————— SET SCALE MODE           									 	
		// Applique un certains type de redimensionnement de l'écran
		
		public function SetScaleMode( Etat:String = "showAll"  // ———— - - Type de redimensionnement choisi
									):void {
			/*—*/
			
			// Calibre le type
			if( Etat == "showAll" ){ Etat = "SHOW_ALL"; }
			else if( Etat == "noBorder" ){ Etat = "NO_BORDER"; }
			else if( Etat == "exactFit" ){ Etat = "EXACT_FIT"; }
			else if( Etat == "noScale" ){ Etat = "NO_SCALE"; }
			else { Etat = Etat.toUpperCase(); }
			
			// Lance le redimensionnement
			StageLink.scaleMode = StageScaleMode[ Etat ];
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					ACTION					  		  					  */
		/*					Méthodes pour lancer des actions relative à la gestion système du Flash 			  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - SET - - —————————————————————————————————————————— */
		// Les méthodes pour modifier la présentation du Flash
	  	//*—*//
		
		// —————— FULL SCREEN      									 	
		// Affiche la scène en plein écran
		
		public function FullScreen( Etat:Boolean = true		// ———— - - Si on active ou désactive le plein-écran
								   ):void {
			/*—*/
			
			// Lance la modification
			try{ fscommand( "fullscreen" , String( Etat ) ); } 
			catch( e ){}
		}
			
			
		// —————— SET RESIZABLE           									 	
		// Indique si la scène se redimentionne ou pas
		
		public function SetResizable( Etat:Boolean = true 	// ———— - - S'il est redimensionnable ou non
								  ):void {
			/*—*/
			
			// Essaye —— - -
			try{
				
				// Redimensionne
				fscommand( "allowscale" , String( Etat ) );
				
				// Switch la valeur correspondante
				Resizable = Etat;
				
			} catch( e ){}
		}
			
			
		// —————— MENU           									 	
		// Affiche / ou cache le menu
		
		public function Menu( Etat:Boolean = true	 // ———— - - Si on l'affiche ou on le cache
							 ):void {
			/*—*/
			
			// Lance la modification
			try { fscommand( "showmenu" , String( Etat ) ); } 
			catch( e ){}
		}
		
		
		// —————— QUIT 	
		// Ferme la scène flash
		
		public function Quit():void {
			/*—*/
			
			// Lance l'action de quitter
			fscommand( "quit" )
		}
			
			
		// —————— PASTE
		// Met une chaine de caractère dans le press-papier
		
		public function Paste( Chaine:*	// ———— - - La chaine à copier
							  ):void {
			/*—*/
			
			// Mise de la chaîne dans le presse-papier
			flash.system.System.setClipboard( String( Chaine ) );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 MENU					  		  					  */
		/*						  				Intégrer des menus particuliers 					  			  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - SET - - —————————————————————————————————————————— */
		// Les méthodes pour appliquer des menus
		//*—*//
	  
		// —————— HIDE MENU         									 	
		//	Cache le menu clic-droit flash ( Sauf ce qui reste obligatoire )
	
		public function HideMenu( Element:* ):void {
			/*—*/
			
			// Ajoute un menu vide
			AddMenu( Element , [] );
		}
	  
	  
		// ——————  ADD MENU     									 	
		//	Ajoute un menu personnalisé sur un élément
		
		public function AddMenu( Element:* ,	// ———— - - Element concerné
								 Menu:Array		// ———— - - Personnalisation du menu ( Tableau d'objets aux clés : Nom , Separateur , Actif )
								):void {
			/*—*/
			
			// Créait l'objet du menu contextuel
			Element.MenuContextuel = new Object();
			
			// Créait le nouveau menu contextuel
			Element.MenuContextuel.Menu = new ContextMenu();
	
			// Cache les autres formes de menu contextuel
			Element.MenuContextuel.Menu.hideBuiltInItems();
			
			// Ajoute les personnalisation de menu
			Element.contextMenu = Element.MenuContextuel.Menu;
			
			// Créait les tableau de personnalisation
			Element.MenuContextuel.ContenuMenu = new Array();
			Element.MenuContextuel.ContenuMenuFonction = new Array();
			
			// Pour chaque personnalisation —— - -
			for( var i:int = 0 ; i < Menu.length ; i++ ){
				
				// Donne son nom
				Element.MenuContextuel.ContenuMenu[ Element.MenuContextuel.ContenuMenu.length ] = new ContextMenuItem( Menu[ i ].Nom , 
																													   Menu[ i ].Separateur , 
																										( Menu[ i ].Actif == null ) ? true : Menu[ i ].Actif )
				
				// Donne sa fonction s'il en a une
				//
				if( Menu[ i ].Fonction ){
					//
					Element.MenuContextuel.ContenuMenu[ Element.MenuContextuel.ContenuMenu.length - 1 ].addEventListener( 
														ContextMenuEvent.MENU_ITEM_SELECT, Menu[ i ].Fonction );
				}
			}
			
			// Ajoute les customisation de menu
			Element.MenuContextuel.Menu.customItems = FusionArray( Element.MenuContextuel.Menu.customItems , Element.MenuContextuel.ContenuMenu );
		}
	  
	  
		// ——————  REFRESH MENU     									 	
		// Remet le menu par défaut et enléve le menu personnalisé s'il y en avait un
		
		public function RefreshMenu( Element:*	// ———— - - Element concerné
									):void {
			/*—*/
			
			// Ajoute un menu vide
			AddMenu( Element , [] );
			
			// S'il a eu un menu précédemment ▼▼
			if( Element.MenuContextuel ){
				
				// Le fait passer à null
				Element.contextMenu = null
				Element.MenuContextuel.Menu.customItems = null
			}
		}
		
		
		// —————— HELP MENU
		//	Applique à un élément un menu particulier
	
		public function HelpMenu( Element:*	// ———— - - Élément Concerné
								 ):void {
			/*—*/
			
			// Définit l'objet des fonctions
			Element.FonctionMenuContextuel = new Object();
			
			// Définit les fonctions —— - -
			//
			// Fonction de données
			Element.FonctionMenuContextuel.DonneNom = function( event:ContextMenuEvent ){ System.setClipboard( Element.name ); }
			Element.FonctionMenuContextuel.DonneChemin = function( event:ContextMenuEvent ){ System.setClipboard( ElementToString( Element ) ); }
			Element.FonctionMenuContextuel.RetireMenu = function( event:ContextMenuEvent ){ RefreshMenu( Element ); }
			//
			// Fonction de modification rotation
			Element.FonctionMenuContextuel.Rotation45 = function( event:ContextMenuEvent ){ Element.rotation += 45; }
			Element.FonctionMenuContextuel.Rotation90 = function( event:ContextMenuEvent ){ Element.rotation += 90; }
			Element.FonctionMenuContextuel.Rotation180 = function( event:ContextMenuEvent ){ Element.rotation += 180; }
			//
			// Fonction de modification alpha
			Element.FonctionMenuContextuel.Alpha100 = function( event:ContextMenuEvent ){ Element.alpha = 1; }
			Element.FonctionMenuContextuel.Alpha50 = function( event:ContextMenuEvent ){ Element.alpha = 0.5; }
			Element.FonctionMenuContextuel.Alpha0 = function( event:ContextMenuEvent ){ Element.alpha = 0; }
			//
			// Fonction d'agissement élement
			Element.FonctionMenuContextuel.Destroy = function( event:ContextMenuEvent ){ DestroyElement( Element ); }
			Element.FonctionMenuContextuel.RemoveEvents = function( event:ContextMenuEvent ){ RemoveEvents( Element ); }
			
			// Ajoute tout les menus
			AddMenu( Element , [  { Nom:" ☼☼☼☼☼☼☼☼☼ Suppr. Menu ☼☼☼☼☼☼☼☼☼" , 	
									 Fonction:Element.FonctionMenuContextuel.RetireMenu				} ,
								   { Nom:" ==> " + Element.name + 
									 "  ( " + TypeOf( Element ) + " , " + Element.width + "x" + Element.height + 
									 " , " + Element.rotation + "°" + 
									 " , " + ( Element.alpha * 100 ) + "a" + " )", 	
									 Fonction:Element.FonctionMenuContextuel.DonneNom 		} ,
								   { Nom:" ==> Way" , 			  	Fonction:Element.FonctionMenuContextuel.DonneChemin				} ,
								  { Nom:"Turn 45°" , 			  	Fonction:Element.FonctionMenuContextuel.Rotation45				  , Separateur:true	 	} ,
								   { Nom:"Turn 90°" , 			  	Fonction:Element.FonctionMenuContextuel.Rotation90			 	} ,
								   { Nom:"Turn 180°" , 			  	Fonction:Element.FonctionMenuContextuel.Rotation180			 	} ,
								   { Nom:"Alpha to 100" , 			Fonction:Element.FonctionMenuContextuel.Alpha100				  , Separateur:true	 	} ,
								   { Nom:"Alpha to 50" , 			Fonction:Element.FonctionMenuContextuel.Alpha50				 	} ,
								   { Nom:"Alpha to 0" , 			Fonction:Element.FonctionMenuContextuel.Alpha0				 	} ,
								   { Nom:"Destroy" , 				Fonction:Element.FonctionMenuContextuel.Destroy				 	  , Separateur:true	 	} ,
								   { Nom:"Remove Events" , 			Fonction:Element.FonctionMenuContextuel.RemoveEvents			}
								 ] );
		}
	  
	  
		// —————— TOTAL HELP MENU        									 	
		//	Donne à un élément et tout ses enfants des menus d'aide contextuels
		
		public function TotalHelpMenu( Element:*	// ———— - - Élément de départ concerné
									 ):void {
			/*—*/
			
			// Si l'enfant est considéré comme un nœud —— - -
			if( Element.IsNode ){
			
				// Donne le menu à l'enfant
				HelpMenu( Element );
			
			// S'il n'est pas considéré comme un nœud —— - -
			} else {
				
				// Essaye —— - -
				try{ 
				
					// Pour chaque enfant du parent —— - -
					for( var i:int = 0 ; i < Element.numChildren ; i++ ){
						
						// Récupére l'instance de l'enfant
						var leClip:* = Element.getChildAt( i );
						
						// Si ce n'est pas une shape —— - -
						if( !TypeOf( leClip , "MorphShape" ) && !TypeOf( leClip , "Shape" ) ){
							
							// Lance l'absolut Help Menu dans l'enfant
							TotalHelpMenu( leClip );
						}
					}
				//
				} catch( e ){}
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 TIE					  		  					  */
		/*						  Méthodes pour relier un état de l'interface à des éléments 					  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - SET - - —————————————————————————————————————————— */
		// Les méthodes pour relier les états aux éléments
		//*—*//
		
		// —————— TIE SCREEN POSITION
		//	Maintient la position du clip selon un des bords de l'écran
		
		public function TieScreenPosition( Clip:* ,							// ———— - - Le Clip concerné
										   Direction:String = "left" ,		// ———— - - La Direction sur la position
										   Parametres:Object = null			// ———— - - Les Parametres de l'attache
										 ):void { 
			/*—*/
			
			// Arguments par défaut
			Parametres = Parametres || new Object();
			//
			var Position:String = Parametres.position || ( ( Direction == "left" || Direction == "right" ) ? "x" : "y" );
			var Bump:Number = Parametres.bump || 0;
			var Limite:Number = Parametres.limit || 666;
			
			// Lance le contrôle écran
			ScreenManage();
			
			// Récupère la position
			var laPosition:String = Position.toUpperCase();
			//
			// Créait la variable de direction
			var laDirection:String;
			
			// Convertie la variable de direction
			if( Direction == "left" ){ laDirection = "Min"; }
			else if( Direction == "right" ){ laDirection = "Max"; }
			else if( Direction == "up" ){ laDirection = "Min"; }
			else if( Direction == "down" ){ laDirection = "Max"; }
			else if( Direction == "center" ){ laDirection = "Cen"; }
			
			// Si la demande de position est compréhensible —— - -
			if( this[ laPosition + laDirection ] != null ){
				
				// Donne au clip son nouvel objet de gestion écran
				Clip.ObjetGestionEcran = Clip.ObjetGestionEcran || new Object();
				//
				// Donne à l'objet du clip l'objet de cette position
				Clip.ObjetGestionEcran[ "Position" + laPosition ] = new Object();
				//
				// Lien Computer
				Clip.ObjetGestionEcran[ "Position" + laPosition ].Computer = this;
				//
				// Nom de variable liée
				Clip.ObjetGestionEcran[ "Position" + laPosition ].Lien = laPosition + laDirection;
				//
				// Position et Bump
				Clip.ObjetGestionEcran[ "Position" + laPosition ].Position = Position;
				Clip.ObjetGestionEcran[ "Position" + laPosition ].Bump = Bump;
				Clip.ObjetGestionEcran[ "Position" + laPosition ].Limite = Limite;
				
				// Donne la boucle —— - -
				Clip.ObjetGestionEcran[ "Position" + laPosition ].Boucle = function( event:Event ):void {
					
					// Récupère l'instance de la cible et de l'objet
					var Cible:* = event.target;
					var Objet:Object = Clip.ObjetGestionEcran[ "Position" + laPosition ];

					// Modifie sa position
					Cible[ Objet.Position ] = ( Objet.Computer[ Objet.Lien ] + Objet.Bump );
					//
					// Bloque à la limite —— - -
					if( Objet.Limite != 666 ){
						
						// S'il dépasse —— - -
						if( Direction == "right" && Cible[ Objet.Position ] > Objet.Limite
						 || Direction == "down" && Cible[ Objet.Position ] > Objet.Limite
						 || Direction == "left" && Cible[ Objet.Position ] < Objet.Limite
						 || Direction == "up" && Cible[ Objet.Position ] < Objet.Limite ){
							
							// Il reste à la limite
							Cible[ Objet.Position ] = Objet.Limite;
						}
					}
				}
				//
				// Donne l'événement de boucle au clip
				AddEvents( Clip , Clip.ObjetGestionEcran[ "Position" + laPosition ].Boucle , "ENTER_FRAME" );
				
			// Si la demande n'est pas compréhensible —— - - Trace l'erreur
			} else { TraceError( "SystemTools" , "PositionEcran" , 
								 "La position/Direction : «" + Position + " " + Direction + "» n'existe pas." ); }
		}
		
			
		// —————— TIE SCREEN SCALE
		// Maintient la taille du clip selon la taille de l'écran
		
		public function TieScreenScale( Clip:* ,					// ———— - - Le clip concerné
										Taille:String = "width" ,	// ———— - - La taille concernée
										Bump:Number = 0				// ———— - - Le bump de taille
									   ):void {
			/*—*/
			
			// Lance le contrôle écran
			ScreenManage();
			
			// Récupère la valeur de taille
			var laTaille:String = NameCase( Taille );
			
			// Si la demande de taille est compréhensible —— - -
			if( this[ "Screen" + laTaille ] != null ){
				
				// Donne au clip son nouvel objet de gestion écran
				Clip.ObjetGestionEcran = Clip.ObjetGestionEcran || new Object()
				//
				// Donne à l'objet son objet de gestion de cette taille
				Clip.ObjetGestionEcran[ "Taille" + laTaille ] = new Object();
				//
				// Lien vers le Computer
				Clip.ObjetGestionEcran[ "Taille" + laTaille ].Computer = this;
				//
				// Nom de la variable liée
				Clip.ObjetGestionEcran[ "Taille" + laTaille ].Lien = "Screen" + laTaille;
				//
				// Taille et bump
				Clip.ObjetGestionEcran[ "Taille" + laTaille ].Taille = Taille;
				Clip.ObjetGestionEcran[ "Taille" + laTaille ].Bump = Bump;
				
				// Donne la boucle —— - -
				Clip.ObjetGestionEcran[ "Taille" + laTaille ].Boucle = function( event:Event ):void {
					
					// Récupère l'instance du clip et de l'objet
					var Cible:* = event.target;
					var Objet:Object = Clip.ObjetGestionEcran[ "Taille" + laTaille ];

					// Modifie la taille ( Si à 0 ou moins, mes à 1 )
					Cible[ Objet.Taille ] = ( Objet.Computer[ Objet.Lien ] + Objet.Bump <= 0 ) ? 1 : Objet.Computer[ Objet.Lien ] + Objet.Bump;
				}
				//
				// Donne l'événement de boucle
				AddEvents( Clip , Clip.ObjetGestionEcran[ "Taille" + laTaille ].Boucle , "ENTER_FRAME" );
				
			// Si la demande de taille est incompréhensible —— - - Trace l'erreur
			} else { TraceError( "SystemTools" , "TailleEcran" , "La Taille : «" + Taille + "» n'existe pas." ); }
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					INTERFACE					  		  				  */
		/*						Méthodes pour appliquer des ensembles de définitions en une fois 				  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - SET - - —————————————————————————————————————————— */
		// Les méthodes pour appliquer les interfaces
		//*—*//
		
		// —————— SET INTERFACE STANDARD
		// Plein écran, pas de clic droit et un redimensionnement standard
		
		public function SetInterfaceStandard():void {
			/*—*/
			
			// Cache le menu
			HideMenu( RootLink );
			//
			// Mes plein écran
			FullScreen();
			//
			// Définit en showAll le type de redimension
			SetScaleMode( "showAll" );
		}
		
		

		
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}