﻿/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***			        			TREE LINK	  			Version 0.1.0									***/
/***				   				   Dernière Mise à Jour : 10-09-06										***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***												      													***/
/***				         				  Liaison Multiple												***/
/***	Ce script établit la connection avec d'autres scènes, flash de façon simultanée afin de permettre   ***/
/***	la gestion d'application multiplayers ou la gestion d'un logiciel par interface externe.		  	***/
/***												      													***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
/***					   					 drOIde version 1.0				      							***/
/***					    				  MIND version 1.0					    						***/
/*** —————————————————————————————————————————————————————————————————————————————————————————————————————— ***/
//
// © Ockam Razor — ockam.razor@gmail.com
// drOIde pakage — Since 21/10/2009
// MIND universe — Since 26/12/2009




// —————————————— - -	Début de Script
package drOIde.Link {
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	    	 						  IMPORT											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	//*——*//
	 
	// —— - - DISPLAY
	import flash.display.MovieClip;
	import flash.display.LoaderInfo;
	//
	// —— - - NET
	import flash.net.XMLSocket;
	//
	// —— - - EVENT
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.DataEvent;
	//
	// —— - - drOIde
	import drOIde.Global.MiscTools;
	
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*				 	   	  						DÉBUT DE CLASSE											  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	  
	public class TreeLink extends MiscTools {
		
	
	
	
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	/*												   				  										  */
	/*				 	      					  VARIABLES GLOBALES										  */
	/*		  							 Les variables d'utilisations globales								  */
	/*												   				  										  */
	/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		//*——*//
		
		// —————— IDENTIFIANT
		// Identifiant de la scène en court
		public var ID:String;
		
		
		// —————— SERVEUR
		// Connexion au serveur
		var Server:XMLSocket;
		
		
		// —————— LIAISONS
		// Les liaisons établie pour la réceptions de données
		var Links:Object = new Object();
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	  					      INITIALISATION									    	  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
	    /**/
		/**/
		public function TreeLink( TheLink:* = null		// ———— - - Lien vers la scène
								 ):void {
			/*—*/
			
			// Établit la connexion
			Connexion( TheLink );
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    					 GLOBAL					  		  					  */
		/*											Gestion global du script 					  				  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - LINK - - —————————————————————————————————————————— */
		// Les méthodes pour établir des connexion
		//*—*//
		
		// —————— LAUNCH CONNEXION
	  	// Envoie un appel de connexion
	  
		public function LaunchConnexion( IP:String = "" ,		// ———— - - IP Transmis ( Ne rien mettre pour une connexion en local )
										 Fonction:* = null ,	// ———— - - Fonction appelée en cas de connexion réussie
									     Erreur:* = null		// ———— - - Fonction appelée en cas de connexion échouée
									   ):void {
			/*—*/
			
			// Variables par défaut
			IP = ( IP == "" ) ? "127.0.0.1" : IP;
			
			// Création de l'objet de sortie
			var ObjetSortie:Object = new Object();
			//
			ObjetSortie.ConnexionTerminee = function( event:Event ):void {
				
				// Si la connexion a réussie —— - -
				if( event.type == "connect" ){
					
				  // Lance la méthode associée
				  Launch( Fonction );
				
				// Si la connexion a échouée —— - -
				} else {
					
				  // Lance la méthode associée
				  Launch( Erreur );
				}
			
				// Retire l'événement de connection
				RemoveEvents( Server , ObjetSortie.ConnexionTerminee , "CONNECT" , "ConnectionServerCheck" );
				RemoveEvents( Server , ObjetSortie.ConnexionEchouee , "IO_ERROR" , "ConnectionServerError" );
			}
			//
			ObjetSortie.ConnexionEchouee = function( event:Event ):void {
				
				// Lance la méthode associée
				 Launch( Erreur );
			
				// Retire l'événement de connection
				RemoveEvents( Server , ObjetSortie.ConnexionTerminee , "CONNECT" , "ConnectionServerCheck" );
				RemoveEvents( Server , ObjetSortie.ConnexionEchouee , "IO_ERROR" , "ConnectionServerError" );
			}
			
			// Créait l'événement de connection
			AddEvents( Server , ObjetSortie.ConnexionTerminee , "CONNECT" , "ConnectionServerCheck" );
			AddEvents( Server , ObjetSortie.ConnexionEchouee , "IO_ERROR" , "ConnectionServerError" );
			
			// Etablissement de la connexion
			Server.connect( IP , 1024 );
		}
		
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				    CONNEXION					  		  				  */
		/*											  Etablir des connexions 					  				  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - EMISSION - - —————————————————————————————————————————— */
		// Les méthodes pour émettre des appels
		//*—*//
		
		// —————— SEND
	  	// Envoie un appel
	  
		public function Send( Message:String	// ———— - - Message à transmettre
							 ):void {
			/*—*/
			
			// Ajoute au message l'ID
			Message = ID + "►IP◄" + Message;
			
			// Transmet le message
			Server.send( Message );
		}
		
		
		// —————— SEND OBJECT
	  	// Envoie un appel d'un objet convertie automatiquement
	  
		public function SendObject( Objet:Object	// ———— - - Objet à transmettre
								   ):void {
			/*—*/
			
			// Lance la transmission du message après conversion de l'objet
			Send( ObjectToGet( Objet , "►EGAL◄" , "►ET◄" ) );
		}
		
		
		
		/* —————————————————————————————————————————— - - RECEPTION - - —————————————————————————————————————————— */
		// Les méthodes pour recevoir des appels
		//*—*//
		
		// —————— RECEPTION
	  	// Réceptionne un appel et ne le traite que s'il n'appartient pas au même ID
	  
		public function Reception( Message:String ,			// ———— - - Le Message transmis
								   Fonction:* = null ,		// ———— - - La Fonction sous-traitant le message
								   Traitement:String = ""	// ———— - - Le Traitement du message
								  ):void {
			/*—*/
			
			// Convertie le message
			Message = Message.split( "\r\n" ).join( "" );
			
			// Sépare le message et l'ID
			var MessageID:String = Message.split( "►IP◄" )[ 0 ];
			var Message:String = Message.split( "►IP◄" )[ 1 ];
			
			// Si l'ID n'est pas le même —— - -
			if( MessageID != ID ){
			
				// Convertie le message en sortie
				var Sortie:* = Message;
				
				// S'il y a un traitement et qu'il existe —— - -
				if( Traitement != "" ){
					//
					if( This[ Traitement ] ){
						
						// Convertie le message par le traitement
						Sortie = This[ Traitement ]( Sortie );
					}
				}
				
				// Lance la fonction avec le message
				Launch( Fonction , true , Sortie );
			}
		}
	  
		// —————— RECEPTION LINK
	  	// Établie une connection entre la réception de données et une fonction
	  
		public function ReceptionLink( Nom:String = "Lien" ,		// ———— - - Le Nom de la connexion de réception
									   Fonction:* = null ,			// ———— - - La Fonction de réception
									   Traitement:String = "" ,		// ———— - - Le Post-traitement du message
									   Etat:Boolean = true			// ———— - - Si on Connecte le lien ou on le déconnecte
									 ):void {
			/*—*/
			
			// Si on créait la connexion —— - -
			if( Etat ){
				
				// Créait l'objet de fonction 
				Links[ Nom ] = new Object();
				//
				Links[ Nom ].Fonction = Fonction;
				Links[ Nom ].Traitement = Traitement;
				//
				Links[ Nom ].ReceptionDonnees = function( event:DataEvent ):void {
					
					// Transmet le message à la fonction de réception
					Reception( event.data , Links[ Nom ].Fonction , Links[ Nom ].Traitement );
				}
				
				// Créait l'événement de réception de donnes
				AddEvents( Server , Links[ Nom ].ReceptionDonnees , "DATA" , "DataReceive" );
			
			// Si on retire la connexion —— - -
			} else {
				
				// On retire l'événement
				RemoveEvents( Server , Links[ Nom ].ReceptionDonnees , "DATA" , "DataReceive" );
				
				// Supprime l'objet de fonction 
				Links[ Nom ] = null;
			}
		}
		
		
		
		
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		/*												   				  										  */
		/*				 	      	    				      RETURN					  		  				  */
		/*											   Reception de données 					  				  */
		/*												   				  										  */
		/* —————————————————————————————————————————————————————————————————————————————————————————————————————— */
		
		/* —————————————————————————————————————————— - - CONVERSION - - —————————————————————————————————————————— */
		// Les méthodes pour convertir les données réceptionnées
		//*—*//
		
		// —————— SEND TO OBJECT
	  	// Transforme le message en un ensemble de variables
	  
		public function SendToObject( Message:String	// ———— - - Message Concerné
									 ):Object {
			/*—*/
			
			// Renvoie le message convertie en objet par le biais de la réception GET
			return GetToObject( Message , "►EGAL◄" , "►ET◄" );
		}
		
		
		
		
		
	
	// —————————————— - -	Fin de Class
	}
	
	
// —————————————— - -	Fin de Script
}